//# 0 "lib_structures/lib_tree.mqh"
//# 0 "<built-in>"
//# 0 "<command-line>"
//# 1 "/usr/include/stdc-predef.h" 1 3 4
//# 0 "<command-line>" 2
//# 1 "lib_structures/lib_tree.mqh"
//# 31 "lib_structures/lib_tree.mqh"
//# 1 "lib_structures/nodes/lib_obj_node_tree_rb.mqh" 1
//# 31 "lib_structures/nodes/lib_obj_node_tree_rb.mqh"
//# 1 "lib_structures/nodes/lib_base_obj_node_tree_rb.mqh" 1
//# 31 "lib_structures/nodes/lib_base_obj_node_tree_rb.mqh"
//# 1 "lib_structures/nodes/lib_base_obj_node_tree_binary.mqh" 1
//# 31 "lib_structures/nodes/lib_base_obj_node_tree_binary.mqh"
//# 1 "lib_structures/nodes/lib_base_obj_node_tree.mqh" 1
//# 31 "lib_structures/nodes/lib_base_obj_node_tree.mqh"
//# 1 "lib_structures/nodes/lib_base_obj_node.mqh" 1
//# 31 "lib_structures/nodes/lib_base_obj_node.mqh"
//# 1 "lib_structures/nodes/lib_base_obj_typecast.mqh" 1
//# 45 "lib_structures/nodes/lib_base_obj_typecast.mqh"
        template <typename USER_DATA, typename NODE_SUBTYPE, typename NODE_TYPE>
        class _object_typecast_node : protected NODE_SUBTYPE
        {
            public:


                _object_typecast_node() :
                    NODE_SUBTYPE()
                { };

                _object_typecast_node(const NODE_SUBTYPE& p_in) :
                    NODE_SUBTYPE(p_in)
                { };


            public:


                template <typename CUSTOM_DATA>
                const bool _autocreate(const CUSTOM_DATA*& p_assign)
                { return(__autocreate(this_obj, p_assign)); };

                template <typename CUSTOM_DATA>
                const bool _autocreate(CUSTOM_DATA* p_assign)
                { return(__autocreate(this_obj, p_assign)); };

                template <typename CUSTOM_DATA>
                const bool _autocreate(CUSTOM_DATA& p_assign)
                { return(__autocreate(this_obj, p_assign)); };


            private:


                template <typename TARGET_TYPE, typename CUSTOM_DATA>
                const bool __autocreate(TARGET_TYPE*& p_this, CUSTOM_DATA& p_assign)
                {
                    p_this = (dynamic_cast<const TARGET_TYPE*>(&p_assign) == NULL) ? new TARGET_TYPE(p_assign) : new CUSTOM_DATA(p_assign);
                    return(p_this != NULL);
                };

                template <typename TARGET_TYPE, typename CUSTOM_DATA>
                const bool __autocreate(TARGET_TYPE& p_this, CUSTOM_DATA* p_assign)
                {
                    p_this = p_assign;
                    return(true);
                };

                template <typename TARGET_TYPE, typename CUSTOM_DATA>
                const bool __autocreate(TARGET_TYPE*& p_this, const CUSTOM_DATA*& p_assign)
                {
                    p_this = (dynamic_cast<const TARGET_TYPE*>(p_assign) == NULL) ? new TARGET_TYPE(p_assign) : new CUSTOM_DATA(p_assign);

                    return(p_this != NULL);
                };

                template <typename TARGET_TYPE, typename CUSTOM_DATA>
                const bool __autocreate(TARGET_TYPE*& p_this, CUSTOM_DATA*& p_assign)
                {
                    p_this = (dynamic_cast<TARGET_TYPE*>(p_assign) == NULL) ? new TARGET_TYPE(p_assign) : new CUSTOM_DATA(p_assign);
                    return(p_this != NULL);
                };

                template <typename TARGET_TYPE, typename CUSTOM_DATA>
                const bool __autocreate(TARGET_TYPE& p_this, CUSTOM_DATA& p_assign)
                {
                    p_this = p_assign;
                    return(true);
                };

                const bool __autocreate(USER_DATA& p_this, const USER_DATA& p_assign)
                {
                    p_this = (USER_DATA)p_assign;
                    return(true);
                };


            public:


                template <typename CUSTOM_DATA>
                void _autodelete(CUSTOM_DATA& p_assign) const
                { __autodelete(this_obj, p_assign); };

                void _autodelete() const
                { __autodelete(this_obj, this_obj); }


            private:


                template <typename TARGET_TYPE, typename CUSTOM_DATA>
                void __autodelete(TARGET_TYPE*& p_this, CUSTOM_DATA& p_assign) const
                { delete(this_obj); };

                template <typename TARGET_TYPE, typename CUSTOM_DATA>
                void __autodelete(TARGET_TYPE*& p_this, const CUSTOM_DATA*& p_assign) const
                { delete(this_obj); };

                template <typename TARGET_TYPE, typename CUSTOM_DATA>
                void __autodelete(TARGET_TYPE*& p_this, CUSTOM_DATA* p_assign) const
                { delete(this_obj); };

                template <typename TARGET_TYPE>
                void __autodelete(TARGET_TYPE*& p_this, USER_DATA& p_assign) const
                { };

                template <typename TARGET_TYPE, typename CUSTOM_DATA>
                void __autodelete(TARGET_TYPE& p_this, CUSTOM_DATA* p_assign) const
                { };

                template <typename TARGET_TYPE, typename CUSTOM_DATA>
                void __autodelete(TARGET_TYPE& p_this, CUSTOM_DATA& p_assign) const
                { };


            public:



                template <typename CALL_TYPE>
                const bool _cast_compare_operator_greater(CALL_TYPE* p_in) const
                { return(__cast_compare_operator_greater(this_obj, p_in)); };

                template <typename CALL_TYPE>
                const bool _cast_compare_operator_greater(CALL_TYPE& p_in) const
                { return(__cast_compare_operator_greater(this_obj, p_in)); };

                template <typename CALL_TYPE>
                const bool _cast_compare_operator_greater(CALL_TYPE p_in) const
                { return(__cast_compare_operator_greater(this_obj, p_in)); };


                template <typename CALL_TYPE>
                const bool _cast_compare_operator_smaller(CALL_TYPE* p_in) const
                { return(__cast_compare_operator_smaller(this_obj, p_in)); };

                template <typename CALL_TYPE>
                const bool _cast_compare_operator_smaller(CALL_TYPE& p_in) const
                { return(__cast_compare_operator_smaller(this_obj, p_in)); };

                template <typename CALL_TYPE>
                const bool _cast_compare_operator_smaller(CALL_TYPE p_in) const
                { return(__cast_compare_operator_smaller(this_obj, p_in)); };


            private:



                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const bool __cast_compare_operator_greater(TARGET_TYPE*& p_out, SOURCE_TYPE* p_in) const
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(p_in);
                    return((p_tmp == NULL) ? (p_out > TARGET_TYPE(p_in)) : (p_out > p_tmp));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const bool __cast_compare_operator_greater(TARGET_TYPE& p_out, SOURCE_TYPE* p_in) const
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(p_in);
                    return((p_tmp == NULL) ? (p_out > TARGET_TYPE(p_in)) : (p_out > p_tmp));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const bool __cast_compare_operator_greater(TARGET_TYPE*& p_out, SOURCE_TYPE& p_in) const
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(&p_in);
                    return((p_tmp == NULL) ? (p_out > TARGET_TYPE(p_in)) : (p_out > p_tmp));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const bool __cast_compare_operator_greater(TARGET_TYPE& p_out, SOURCE_TYPE& p_in) const
                { return(p_out > TARGET_TYPE(p_in)); };


                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const bool __cast_compare_operator_smaller(TARGET_TYPE*& p_out, SOURCE_TYPE* p_in) const
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(p_in);
                    return((p_tmp == NULL) ? (TARGET_TYPE(p_in) > p_out) : (p_tmp > p_out));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const bool __cast_compare_operator_smaller(TARGET_TYPE& p_out, SOURCE_TYPE* p_in) const
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(p_in);
                    return((p_tmp == NULL) ? (TARGET_TYPE(p_in) > p_out) : (p_tmp > p_out));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const bool __cast_compare_operator_smaller(TARGET_TYPE*& p_out, SOURCE_TYPE& p_in) const
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(&p_in);
                    return((p_tmp == NULL) ? (TARGET_TYPE(p_in) > p_out) : (p_tmp > p_out));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const bool __cast_compare_operator_smaller(TARGET_TYPE& p_out, SOURCE_TYPE& p_in) const
                { return(TARGET_TYPE(p_in) > p_out); };
        };
//# 254 "lib_structures/nodes/lib_base_obj_typecast.mqh"
        template <typename USER_DATA, typename NODE_SUBTYPE, typename NODE_TYPE>
        class _object_typecast_tree_node : public _object_typecast_node<USER_DATA, NODE_SUBTYPE, NODE_TYPE>
        {
            public:


                _object_typecast_tree_node() :
                    _object_typecast_node()
                { };

                _object_typecast_tree_node(const NODE_SUBTYPE& p_in) :
                    _object_typecast_node(p_in)
                { };


            public:


                template <typename CALL_TYPE>
                const NODE_TYPE* _cast_next_greater_operator(CALL_TYPE* p_in, const bool or_equal)
                { return(__cast_next_greater_operator(this_obj, p_in, or_equal)); };

                template <typename CALL_TYPE>
                const NODE_TYPE* _cast_next_greater_operator(CALL_TYPE& p_in, const bool or_equal)
                { return(__cast_next_greater_operator(this_obj, p_in, or_equal)); };

                template <typename CALL_TYPE>
                const NODE_TYPE* _cast_next_greater_operator(CALL_TYPE p_in, const bool or_equal)
                { return(__cast_next_greater_operator(this_obj, p_in, or_equal)); };

                const NODE_TYPE* _cast_next_greater_operator(const USER_DATA& p_in, const bool or_equal)
                { return(__cast_next_greater_operator(this_obj, p_in, or_equal)); };

                const NODE_TYPE* _cast_next_greater_operator(USER_DATA& p_in, const bool or_equal)
                { return(__cast_next_greater_operator(this_obj, p_in, or_equal)); };


            private:


                const NODE_TYPE* __cast_next_greater_operator(USER_DATA& p_out, const USER_DATA& p_in, const bool or_equal)
                { return(NODE_SUBTYPE::greater(p_in, or_equal)); };

                const NODE_TYPE* __cast_next_greater_operator(USER_DATA& p_out, USER_DATA& p_in, const bool or_equal)
                { return(NODE_SUBTYPE::greater(p_in, or_equal)); };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_next_greater_operator(TARGET_TYPE*& p_out, SOURCE_TYPE* p_in, const bool or_equal)
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(p_in);
                    return((p_tmp == NULL) ? NODE_SUBTYPE::greater(TARGET_TYPE(p_in), or_equal) : NODE_SUBTYPE::greater(p_tmp, or_equal));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_next_greater_operator(TARGET_TYPE& p_out, SOURCE_TYPE* p_in, const bool or_equal)
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(p_in);
                    return((p_tmp == NULL) ? NODE_SUBTYPE::greater(TARGET_TYPE(p_in), or_equal) : NODE_SUBTYPE::greater(p_tmp, or_equal));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_next_greater_operator(TARGET_TYPE*& p_out, SOURCE_TYPE& p_in, const bool or_equal)
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(&p_in);
                    return((p_tmp == NULL) ? NODE_SUBTYPE::greater(TARGET_TYPE(p_in), or_equal) : NODE_SUBTYPE::greater(p_tmp, or_equal));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_next_greater_operator(TARGET_TYPE& p_out, SOURCE_TYPE& p_in, const bool or_equal)
                { return(NODE_SUBTYPE::greater(TARGET_TYPE(p_in) , or_equal)); };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_next_greater_operator(TARGET_TYPE& p_out, SOURCE_TYPE p_in, const bool or_equal)
                { return(NODE_SUBTYPE::greater(p_in, or_equal)); };


            public:


                template <typename CALL_TYPE>
                const NODE_TYPE* _cast_next_smaller_operator(CALL_TYPE* p_in, const bool or_equal)
                { return(__cast_next_smaller_operator(this_obj, p_in, or_equal)); };

                template <typename CALL_TYPE>
                const NODE_TYPE* _cast_next_smaller_operator(CALL_TYPE& p_in, const bool or_equal)
                { return(__cast_next_smaller_operator(this_obj, p_in, or_equal)); };

                template <typename CALL_TYPE>
                const NODE_TYPE* _cast_next_smaller_operator(CALL_TYPE p_in, const bool or_equal)
                { return(__cast_next_smaller_operator(this_obj, p_in, or_equal)); };

                const NODE_TYPE* _cast_next_smaller_operator(const USER_DATA& p_in, const bool or_equal)
                { return(__cast_next_smaller_operator(this_obj, p_in, or_equal)); };

                const NODE_TYPE* _cast_next_smaller_operator(USER_DATA& p_in, const bool or_equal)
                { return(__cast_next_smaller_operator(this_obj, p_in, or_equal)); };


            private:


                const NODE_TYPE* __cast_next_smaller_operator(USER_DATA& p_out, const USER_DATA& p_in, const bool or_equal)
                { return(NODE_SUBTYPE::smaller(p_in, or_equal)); };

                const NODE_TYPE* __cast_next_smaller_operator(USER_DATA& p_out, USER_DATA& p_in, const bool or_equal)
                { return(NODE_SUBTYPE::smaller(p_in, or_equal)); };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_next_smaller_operator(TARGET_TYPE*& p_out, SOURCE_TYPE* p_in, const bool or_equal)
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(p_in);
                    return((p_tmp == NULL) ? NODE_SUBTYPE::smaller(TARGET_TYPE(p_in), or_equal) : NODE_SUBTYPE::smaller(p_tmp, or_equal));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_next_smaller_operator(TARGET_TYPE& p_out, SOURCE_TYPE* p_in, const bool or_equal)
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(p_in);
                    return((p_tmp == NULL) ? NODE_SUBTYPE::smaller(TARGET_TYPE(p_in), or_equal) : NODE_SUBTYPE::smaller(p_tmp, or_equal));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_next_smaller_operator(TARGET_TYPE*& p_out, SOURCE_TYPE& p_in, const bool or_equal)
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(&p_in);
                    return((p_tmp == NULL) ? NODE_SUBTYPE::smaller(TARGET_TYPE(p_in), or_equal) : NODE_SUBTYPE::smaller(p_tmp, or_equal));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_next_smaller_operator(TARGET_TYPE& p_out, SOURCE_TYPE& p_in, const bool or_equal)
                { return(NODE_SUBTYPE::smaller(TARGET_TYPE(p_in), or_equal)); };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_next_smaller_operator(TARGET_TYPE& p_out, SOURCE_TYPE p_in, const bool or_equal)
                { return(NODE_SUBTYPE::smaller(p_in, or_equal)); };


            public:


                template <typename CALL_TYPE>
                const NODE_TYPE* _cast_indexing_operator(CALL_TYPE* p_in)
                { return(__cast_indexing_operator(this_obj, p_in)); };

                template <typename CALL_TYPE>
                const NODE_TYPE* _cast_indexing_operator(CALL_TYPE& p_in)
                { return(__cast_indexing_operator(this_obj, p_in)); };

                template <typename CALL_TYPE>
                const NODE_TYPE* _cast_indexing_operator(CALL_TYPE p_in)
                { return(__cast_indexing_operator(this_obj, p_in)); };

                const NODE_TYPE* _cast_indexing_operator(const USER_DATA& p_in)
                { return(__cast_indexing_operator(this_obj, p_in)); };

                const NODE_TYPE* _cast_indexing_operator(USER_DATA& p_in)
                { return(__cast_indexing_operator(this_obj, p_in)); };


            private:


                const NODE_TYPE* __cast_indexing_operator(USER_DATA& p_out, const USER_DATA& p_in)
                { return(NODE_SUBTYPE::operator[](p_in)); };

                const NODE_TYPE* __cast_indexing_operator(USER_DATA& p_out, USER_DATA& p_in)
                { return(NODE_SUBTYPE::operator[](p_in)); };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_indexing_operator(TARGET_TYPE*& p_out, SOURCE_TYPE* p_in)
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(p_in);
                    return((p_tmp == NULL) ? NODE_SUBTYPE::operator[](TARGET_TYPE(p_in)) : NODE_SUBTYPE::operator[](p_tmp));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_indexing_operator(TARGET_TYPE& p_out, SOURCE_TYPE* p_in)
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(p_in);
                    return((p_tmp == NULL) ? NODE_SUBTYPE::operator[](TARGET_TYPE(p_in)) : NODE_SUBTYPE::operator[](p_tmp));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_indexing_operator(TARGET_TYPE*& p_out, SOURCE_TYPE& p_in)
                {
                    const TARGET_TYPE* p_tmp = dynamic_cast<const TARGET_TYPE*>(&p_in);
                    return((p_tmp == NULL) ? NODE_SUBTYPE::operator[](TARGET_TYPE(p_in)) : NODE_SUBTYPE::operator[](p_tmp));
                };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_indexing_operator(TARGET_TYPE& p_out, SOURCE_TYPE& p_in)
                { return(NODE_SUBTYPE::operator[](TARGET_TYPE(p_in))); };

                template <typename TARGET_TYPE, typename SOURCE_TYPE>
                const NODE_TYPE* __cast_indexing_operator(TARGET_TYPE& p_out, SOURCE_TYPE p_in)
                { return(NODE_SUBTYPE::operator[](p_in)); };

        };
//# 32 "lib_structures/nodes/lib_base_obj_node.mqh" 2
//# 51 "lib_structures/nodes/lib_base_obj_node.mqh"
        template <typename USER_DATA, typename NODE_TYPE>
        class _object_node
        {
            public:


                NODE_TYPE* _left;
                NODE_TYPE* _right;
                USER_DATA this_obj;


            public:



                _object_node() :
                    _left (NULL),
                    _right (NULL)
                { };


                _object_node(const NODE_TYPE& p_in)
                {
                    _left = p_in._left;
                    _right = p_in._right;
                };


                ~_object_node()
                { };


            protected:



                NODE_TYPE* top()
                { return(left()); }

                NODE_TYPE* left()
                {
                    NODE_TYPE* ptr_obj = ::GetPointer(this);
                    while( (ptr_obj._left != NULL)
                        && (!_StopFlag) )
                    { ptr_obj = ptr_obj._left; }


                    return(ptr_obj);
                }

                const NODE_TYPE* top() const
                { return(left()); }

                const NODE_TYPE* left() const
                {
                    const NODE_TYPE* ptr_obj = ::GetPointer(this);
                    while( (ptr_obj._left != NULL)
                        && (!_StopFlag) )
                    { ptr_obj = ptr_obj._left; }


                    return(ptr_obj);
                }


                NODE_TYPE* bottom()
                { return(right()); }

                NODE_TYPE* right()
                {
                    NODE_TYPE* ptr_obj = ::GetPointer(this);
                    while( (ptr_obj._right != NULL)
                        && (!_StopFlag) )
                    { ptr_obj = ptr_obj._right; }


                    return(ptr_obj);
                }

                const NODE_TYPE* bottom() const
                { return(right()); }

                const NODE_TYPE* right() const
                {
                    const NODE_TYPE* ptr_obj = ::GetPointer(this);
                    while( (ptr_obj._right != NULL)
                        && (!_StopFlag) )
                    { ptr_obj = ptr_obj._right; }


                    return(ptr_obj);
                }


            public:



                const int size()
                {
                    int count = NULL;
                    const NODE_TYPE* ptr_obj = left();
                    while( (ptr_obj != NULL)
                        && (!_StopFlag) )
                    {
                        ptr_obj = ptr_obj._right;
                        count++;
                    }


                    return(count);
                };





                void operator=(const NODE_TYPE& p_in)
                {
                    _left = p_in._left;
                    _right = p_in._right;
                };

                void operator=(NODE_TYPE* p_in)
                {
                    _left = p_in._left;
                    _right = p_in._right;
                };


                USER_DATA operator=(USER_DATA& p_in)
                {
                    this_obj = p_in;
                    return(this_obj);
                };
        };
//# 32 "lib_structures/nodes/lib_base_obj_node_tree.mqh" 2
//# 54 "lib_structures/nodes/lib_base_obj_node_tree.mqh"
        template <typename USER_DATA, typename NODE_TYPE>
        class _object_t_node : public _object_node<USER_DATA, NODE_TYPE>
        {
            public:



                _object_t_node() :
                    _object_node<USER_DATA, NODE_TYPE> ()
                { };


                _object_t_node(const _object_t_node<USER_DATA, NODE_TYPE>& p_in)
                {
                    _left = p_in._left;
                    _right = p_in._right;
                };


                ~_object_t_node()
                { };





                const NODE_TYPE* left() const
                { return(bottom()); }


                const NODE_TYPE* right() const
                {
                    const _object_t_node<USER_DATA, NODE_TYPE>* ptr_obj = ::GetPointer(this);
                    while( (ptr_obj._left != NULL)
                        && (!_StopFlag) )
                    { ptr_obj = ptr_obj._right; }


                    return(ptr_obj);
                }

                template <typename UNIFIED>
                const NODE_TYPE* greater(const UNIFIED* value, const bool or_equal = false) const
                {

                    const _object_t_node<USER_DATA, NODE_TYPE>* bigger_x = NULL;
                    const _object_t_node<USER_DATA, NODE_TYPE>* prev_x = NULL;
                    const _object_t_node<USER_DATA, NODE_TYPE>* x = ::GetPointer(this);
                    const _object_t_node<USER_DATA, NODE_TYPE>* equal_x = ((or_equal) && !(x.this_obj > value) && !(value > x.this_obj)) ? x : NULL;
                    bool left = false;
                    bool stop = (equal_x != NULL);


                    while(!stop)
                    {
                        left = (x.this_obj > value);
                        prev_x = x;
                        x = (left) ? x._left : x._right;
                        stop |= (x == NULL);
                        equal_x = ((or_equal) && (!stop) && !(x.this_obj > value) && !(value > x.this_obj)) ? x : equal_x;
                        stop |= (stop) || (_StopFlag) || (equal_x != NULL) || (!(x.this_obj > value) && (x._right == NULL));
                        bigger_x = (prev_x.this_obj > value) ? prev_x : bigger_x;
                    }


                    return((equal_x != NULL) ? equal_x : bigger_x);
                }

                template <typename UNIFIED>
                const NODE_TYPE* greater(const UNIFIED& value, const bool or_equal = false) const
                {

                    const _object_t_node<USER_DATA, NODE_TYPE>* bigger_x = NULL;
                    const _object_t_node<USER_DATA, NODE_TYPE>* prev_x = NULL;
                    const _object_t_node<USER_DATA, NODE_TYPE>* x = ::GetPointer(this);
                    const _object_t_node<USER_DATA, NODE_TYPE>* equal_x = ((or_equal) && !(x.this_obj > value) && !(value > x.this_obj)) ? x : NULL;
                    bool left = false;
                    bool stop = (equal_x != NULL);


                    while(!stop)
                    {
                        left = (x.this_obj > value);
                        prev_x = x;
                        x = (left) ? x._left : x._right;
                        stop |= (x == NULL);
                        equal_x = ((or_equal) && (!stop) && !(x.this_obj > value) && !(value > x.this_obj)) ? x : equal_x;
                        stop |= (stop) || (_StopFlag) || (equal_x != NULL) || (!(x.this_obj > value) && (x._right == NULL));
                        bigger_x = (prev_x.this_obj > value) ? prev_x : bigger_x;
                    }


                    return((equal_x != NULL) ? equal_x : bigger_x);
                }

                template <typename UNIFIED>
                const NODE_TYPE* smaller(const UNIFIED* value, const bool or_equal = false) const
                {

                    const _object_t_node<USER_DATA, NODE_TYPE>* smaller_x = NULL;
                    const _object_t_node<USER_DATA, NODE_TYPE>* prev_x = NULL;
                    const _object_t_node<USER_DATA, NODE_TYPE>* x = ::GetPointer(this);
                    cosnt _object_t_node<USER_DATA, NODE_TYPE>* equal_x = ((or_equal) && !(x.this_obj > value) && !(value > x.this_obj)) ? x : NULL;
                    bool left = false;
                    bool stop = (equal_x != NULL);


                    while(!stop)
                    {
                        left = !(value > x.this_obj);
                        prev_x = x;
                        x = (left) ? x._left : x._right;
                        stop |= (x == NULL);
                        equal_x = ((!stop) && (or_equal) && !(x.this_obj > value) && !(value > x.this_obj)) ? x : equal_x;
                        stop |= (stop) || (_StopFlag) || (equal_x != NULL) || (!(value > x.this_obj) && (x._left == NULL));
                        smaller_x = (value > prev_x.this_obj) ? prev_x : smaller_x;
                    }


                    return((equal_x != NULL) ? equal_x : smaller_x);
                }

                template <typename UNIFIED>
                const NODE_TYPE* smaller(const UNIFIED& value, const bool or_equal = false) const
                {

                    const _object_t_node<USER_DATA, NODE_TYPE>* smaller_x = NULL;
                    const _object_t_node<USER_DATA, NODE_TYPE>* prev_x = NULL;
                    const _object_t_node<USER_DATA, NODE_TYPE>* x = ::GetPointer(this);
                    const _object_t_node<USER_DATA, NODE_TYPE>* equal_x = ((or_equal) && !(x.this_obj > value) && !(value > x.this_obj)) ? x : NULL;
                    bool left = false;
                    bool stop = (equal_x != NULL);


                    while(!stop)
                    {
                        left = !(value > x.this_obj);
                        prev_x = x;
                        x = (left) ? x._left : x._right;
                        stop |= (x == NULL);
                        equal_x = ((or_equal) && (!stop) && !(x.this_obj > value) && !(value > x.this_obj)) ? x : equal_x;
                        stop |= (stop) || (_StopFlag) || (equal_x != NULL) || (!(value > x.this_obj) && (x._left == NULL));
                        smaller_x = (value > prev_x.this_obj) ? prev_x : smaller_x;
                    }


                    return((equal_x != NULL) ? equal_x : smaller_x);
                }




                _object_t_node<USER_DATA, NODE_TYPE>* insert(_object_t_node<USER_DATA, NODE_TYPE>* _root, _object_t_node<USER_DATA, NODE_TYPE>*& _this_parent, const bool unique = false)
                {

                    if(_root == NULL)
                    { return(::GetPointer(this)); }


                    bool _stop = false;
                    bool left = false;
                    _object_t_node<USER_DATA, NODE_TYPE>* ptr = _root;
                    _this_parent = NULL;


                    if(unique)
                    {
                        while( (ptr != NULL)
                            && (!_stop) )
                        {
                            _this_parent = ptr;
                            left = !(this_obj > ptr.this_obj);
                            _stop |= _StopFlag || ((left) && !(ptr.this_obj > this_obj));
                            ptr = (left) ? ptr._left : ptr._right;
                        }
                    }
                    else
                    {
                        while( (ptr != NULL)
                            && (!_stop) )
                        {
                            _this_parent = ptr;
                            left = !(this_obj > ptr.this_obj);
                            _stop = _StopFlag;
                            ptr = (left) ? ptr._left : ptr._right;
                        }
                    }


                    if(_stop)
                    {
                        _this_parent = NULL;
                        return(NULL);
                    }


                    if(left)
                    { _this_parent._left = ::GetPointer(this); }
                    else
                    { _this_parent._right = ::GetPointer(this); }


                    return(_root);
                };


                _object_t_node<USER_DATA, NODE_TYPE>* remove()
                {
                    _object_t_node<USER_DATA, NODE_TYPE>* tmp_ptr = NULL;
                    return(remove(tmp_ptr));
                };

                _object_t_node<USER_DATA, NODE_TYPE>* remove(_object_t_node<USER_DATA, NODE_TYPE>*& _this_parent)
                {

                    if( (_this_parent == NULL)
                     && (_left == NULL)
                     && (_right == NULL) )
                     { return(NULL); }


                    _object_t_node<USER_DATA, NODE_TYPE>* _this_node = ::GetPointer(this);
                    _object_t_node<USER_DATA, NODE_TYPE>* _root = (_this_parent == _this_node) ? _this_node : NULL;
                    _object_t_node<USER_DATA, NODE_TYPE>* _sub_parent = NULL;
                    _object_t_node<USER_DATA, NODE_TYPE>* _sub_node = NULL;

                    switch( ((_left != NULL) + (_right != NULL)) << ((_this_node == _root) ? 3 : NULL) )
                    {

                        case 0:

                            if(_this_parent == NULL)
                            { _root = NULL; }


                            else if(_this_parent._right == _this_node)
                            { _this_parent._right = NULL; }


                            else if(_this_parent._left == _this_node)
                            { _this_parent._left = NULL; }





                            _left = NULL;
                            _right = NULL;

                            break;


                        case 1:

                            if(_this_parent == NULL)
                            {
                                _root = (_left != NULL) ? _left : _right;
                                _left = _root;
                            }


                            else if(_this_parent._right == _this_node)
                            {
                                _this_parent._right = (_left != NULL) ? _left : _right;
                                _left = _this_parent._right;
                            }


                            else if(_this_parent._left == _this_node)
                            {
                                _this_parent._left = (_left != NULL) ? _left : _right;
                                _left = _this_parent._left;
                            }





                            _right = _left._right;
                            _this_parent = _left;
                            break;


                        case 2:
                            _sub_parent = _this_node;
                            _sub_node = _subtree_smallest_key(_right, _sub_parent);


                            if(_sub_parent != _this_node)
                            {
                                _sub_parent._left = _sub_node._right;
                                _sub_node._right = _right;
                            }


                            if(_this_parent == NULL)
                            { _root = _sub_node; }


                            else if(_this_parent._right == _this_node)
                            { _this_parent._right = _sub_node; }
                            else
                            { _this_parent._left = _sub_node; }


                            _sub_node._left = _left;





                            _left = _sub_node;
                            _right = (_sub_parent != _this_node) ? _sub_parent._left : _sub_node._right;
                            _this_parent = _sub_parent;
                            break;


                        default:
                            _delete_subnodes(_root);
                            _root._left = NULL;
                            _root._right = NULL;
                    }


                    return(_root);
                };





                void operator=(NODE_TYPE& p_in)
                { _object_node<USER_DATA, NODE_TYPE>::operator=(p_in); };



                template <typename UNIFIED>
                NODE_TYPE* operator[](UNIFIED* p_in)
                {

                    _object_t_node<USER_DATA, NODE_TYPE>* x = ::GetPointer(this);


                    while( (x != NULL)
                        && ((x.this_obj > p_in) || (p_in > x.this_obj)) )
                    { x = (x.this_obj > p_in) ? x._left : x._right; }


                    return(x);
                };

                template <typename UNIFIED>
                NODE_TYPE* operator[](UNIFIED& p_in)
                {

                    _object_t_node<USER_DATA, NODE_TYPE>* x = ::GetPointer(this);


                    while( (x != NULL)
                        && ((x.this_obj > p_in) || (p_in > x.this_obj)) )
                    { x = (x.this_obj > p_in) ? x._left : x._right; }


                    return(x);
                };


            protected:



                NODE_TYPE* _subtree_smallest_key(_object_t_node<USER_DATA, NODE_TYPE>* ptr) const
                {
                    _object_t_node<USER_DATA, NODE_TYPE>* _this_parent = NULL;
                    return(_subtree_smallest_key(ptr, _this_parent));
                };

                NODE_TYPE* _subtree_smallest_key(_object_t_node<USER_DATA, NODE_TYPE>* ptr, _object_t_node<USER_DATA, NODE_TYPE>*& _this_parent) const
                {
                    while( (ptr != NULL)
                        && (ptr._left != NULL) )
                    {
                        _this_parent = ptr;
                        ptr = ptr._left;
                    }
                    return(ptr);
                };


                NODE_TYPE* _subtree_greatest_key(_object_t_node<USER_DATA, NODE_TYPE>* ptr) const
                {
                    _object_t_node<USER_DATA, NODE_TYPE>* _this_parent = NULL;
                    return(_subtree_greatest_key(ptr, _this_parent));
                };

                NODE_TYPE* _subtree_greatest_key(_object_t_node<USER_DATA, NODE_TYPE>* ptr, _object_t_node<USER_DATA, NODE_TYPE>*& _this_parent) const
                {
                    while( (ptr != NULL)
                        && (ptr._right != NULL) )
                    {
                        _this_parent = ptr;
                        ptr = ptr._right;
                    }
                    return(ptr);
                };


                const bool _delete_subnodes(_object_t_node<USER_DATA, NODE_TYPE>* p_in)
                {

                    if(p_in == NULL)
                    { return(false); }


                    if(_delete_subnodes(p_in._left))
                    { delete(p_in._left); }


                    if(_delete_subnodes(p_in._right))
                    { delete(p_in._right); }


                    return(true);
                };


            public:


                const string _node_to_string() { return(__obj_to_string(this_obj)); };
                const string __obj_to_string(uchar p_in) { return(StringFormat("%u", p_in)); };
                const string __obj_to_string(ushort p_in) { return(StringFormat("%u", p_in)); };
                const string __obj_to_string(uint p_in) { return(StringFormat("%u", p_in)); };
                const string __obj_to_string(ulong p_in) { return(StringFormat("%llu", p_in)); };
                const string __obj_to_string(char p_in) { return(StringFormat("%i", p_in)); };
                const string __obj_to_string(short p_in) { return(StringFormat("%i", p_in)); };
                const string __obj_to_string(int p_in) { return(StringFormat("%i", p_in)); };
                const string __obj_to_string(long p_in) { return(StringFormat("%lli", p_in)); };
                const string __obj_to_string(datetime p_in) { return(TimeToString(p_in)); };
                const string __obj_to_string(color p_in) { return(ColorToString(p_in)); };
                const string __obj_to_string(float p_in) { return(StringFormat("%f", p_in)); };
                const string __obj_to_string(double p_in) { return(StringFormat("%f", p_in)); };
                template <typename T>
                const string __obj_to_string(T& p_in) { return(typename(p_in)); };
        };
//# 32 "lib_structures/nodes/lib_base_obj_node_tree_binary.mqh" 2
//# 55 "lib_structures/nodes/lib_base_obj_node_tree_binary.mqh"
        template <typename USER_DATA>
        class _object_binary_t_node : public _object_t_node<USER_DATA, _object_binary_t_node<USER_DATA> >
        {
            protected:


                _object_binary_t_node<USER_DATA>* _parent;


            public:



                _object_binary_t_node() :
                    _object_t_node<USER_DATA, _object_binary_t_node<USER_DATA> >(),
                    _parent (NULL)
                { };


                _object_binary_t_node(const _object_binary_t_node<USER_DATA>& p_in)
                {
                    remove(_parent);
                    _object_t_node<USER_DATA, _object_binary_t_node<USER_DATA> >(p_in);
                    _parent = p_in._parent;
                };


                ~_object_binary_t_node()
                {
                    if( (_parent == NULL)
                     && (_left == NULL)
                     && (_right == NULL) )
                    { return; }
                    remove(::GetPointer(this));
                };





                const _object_binary_t_node<USER_DATA>* top() const
                { return(root()); }

                const _object_binary_t_node<USER_DATA>* root() const
                {
                    const _object_binary_t_node<USER_DATA>* ptr_obj = ::GetPointer(this);
                    while( (ptr_obj._parent != NULL)
                        && (!_StopFlag) )
                    { ptr_obj = ptr_obj._parent; }


                    return(ptr_obj);
                }





                _object_binary_t_node<USER_DATA>* insert(_object_binary_t_node<USER_DATA>* _root, const bool unique = false)
                {
                    _object_t_node<USER_DATA, _object_binary_t_node<USER_DATA> >* tmp_ptr = _parent;
                    _root = _object_t_node<USER_DATA, _object_binary_t_node<USER_DATA> >::insert(_root, tmp_ptr, unique);
                    _parent = tmp_ptr;
                    return(_root);
                };


                _object_binary_t_node<USER_DATA>* remove(_object_binary_t_node<USER_DATA>* _root, const bool do_not_delete = false)
                {

                    if(_root == NULL)
                    { return(NULL); }


                    _object_t_node<USER_DATA, _object_binary_t_node<USER_DATA> >* sub_parent = _parent;
                    _object_binary_t_node<USER_DATA>* tmp_ptr = _object_t_node<USER_DATA, _object_binary_t_node<USER_DATA> >::remove(sub_parent);
                    _root = (tmp_ptr != NULL) ? tmp_ptr : _root;
                    tmp_ptr = ::GetPointer(this);


                    if( (_root == tmp_ptr)
                       && (_right == NULL)
                       && (_left == NULL) )
                    { return(NULL); }
//# 154 "lib_structures/nodes/lib_base_obj_node_tree_binary.mqh"
                    if(_left != NULL)
                    {

                        _left._parent = _parent;


                        if(_left._left != NULL)
                        { _left._left._parent = _left; }

                        if(_left._right != NULL)
                        { _left._right._parent = _left; }


                        if( (sub_parent != _left)
                         && (sub_parent != tmp_ptr) )
                        {
                            if(sub_parent._left != NULL)
                            { sub_parent._left._parent = sub_parent; }

                            if(sub_parent._right != NULL)
                            { sub_parent._right._parent = sub_parent; }
                        }
                    }


                    _root._parent = NULL;


                    _left = (do_not_delete) ? _left : NULL;
                    _right = (do_not_delete) ? _right : NULL;
                    _parent = (do_not_delete) ? sub_parent : NULL;


                    return(_root);
                }





                void operator=(const _object_binary_t_node<USER_DATA>& p_in)
                {
                    remove(_parent);
                    _object_t_node<USER_DATA, _object_binary_t_node<USER_DATA> >::operator=((_object_t_node<USER_DATA, _object_binary_t_node<USER_DATA> >)p_in);
                    _parent = p_in._parent;
                };

                void operator=(_object_binary_t_node<USER_DATA>* p_in)
                {
                    remove(_parent);
                    _object_t_node<USER_DATA, _object_binary_t_node<USER_DATA> >::operator=((_object_t_node<USER_DATA, _object_binary_t_node<USER_DATA> >*)p_in);
                    _parent = p_in._parent;
                };


            public:


                const string _node_to_string(int& count)
                {
                    if( ( _parent != NULL)
                     && (CheckPointer(_parent) == POINTER_INVALID) )
                    { return(NULL); }
                    count++; return(StringFormat("Parent Value: %s; Value: %s", (_parent != NULL) ? __obj_to_string(_parent.this_obj) : "Root-Node", __obj_to_string(this_obj))); };
        };
//# 32 "lib_structures/nodes/lib_base_obj_node_tree_rb.mqh" 2
//# 54 "lib_structures/nodes/lib_base_obj_node_tree_rb.mqh"
        template <typename USER_DATA>
        class _object_rb_t_node : public _object_binary_t_node<USER_DATA>
        {
            protected:


                uchar _state;


            public:



                _object_rb_t_node() :
                    _object_binary_t_node<USER_DATA> (),
                    _state (1)
                { };


                _object_rb_t_node(const _object_rb_t_node<USER_DATA>& p_in)
                {
                    remove(::GetPointer(this));
                    _object_binary_t_node<USER_DATA>(p_in);
                };


                ~_object_rb_t_node()
                {
                    if( (_parent == NULL)
                     && (_left == NULL)
                     && (_right == NULL) )
                    { return; }
                    remove(::GetPointer(this));
                };





                _object_rb_t_node<USER_DATA>* insert(_object_rb_t_node<USER_DATA>* _root)
                {

                    _root = _object_binary_t_node<USER_DATA>::insert(_root, true);


                    if( (_root == NULL)
                     && (_parent == NULL) )
                    { return(NULL); }


                    _root._state = NULL;


                    return((_parent._parent != NULL) ? _insert_fixup(_root) : _root);
                };


                _object_rb_t_node<USER_DATA>* remove(_object_rb_t_node<USER_DATA>* _root, const bool do_not_delete = false)
                {

                    if(_root == NULL)
                    { return(NULL); }


                    const uchar this_state = _state;
                    bool red_leaf = (this_state != NULL) && (_left == NULL) && (_right == NULL);
                    bool right_double_red = false;
                    bool left_double_red = false;
                    bool b_fixup = false;


                    _object_rb_t_node<USER_DATA>* tmp_ptr = _object_binary_t_node<USER_DATA>::remove(_root, true);
                    _root = (tmp_ptr != NULL) ? tmp_ptr : _root;
                    tmp_ptr = ::GetPointer(this);


                    if( (_root == tmp_ptr)
                       && (_right == NULL)
                       && (_left == NULL) )
                    { return(NULL); }


                    if(_left != NULL)
                    {
                        _state = ((_object_rb_t_node<USER_DATA>*)_left)._state;
                        b_fixup = (_right == NULL) && (_state == NULL);
                        right_double_red = (this_state != NULL) && (_left._right != NULL) && (((_object_rb_t_node<USER_DATA>*)_left._right)._state != NULL);
                        left_double_red = (this_state != NULL) && (_left._left != NULL) && (((_object_rb_t_node<USER_DATA>*)_left._left)._state != NULL);
                        red_leaf = (_right == NULL) && (_state != NULL);
                        ((_object_rb_t_node<USER_DATA>*)_left)._state = this_state;
                        b_fixup |= (((_state + this_state) != 1) && (!red_leaf)) || right_double_red || left_double_red;
                    }
                    else
                    {
                        _state = NULL;
                        b_fixup = (!red_leaf) && ((_state + this_state) != 1);
                    }





                    if( (b_fixup)
                     && (_root != tmp_ptr) )
                    {
//# 173 "lib_structures/nodes/lib_base_obj_node_tree_rb.mqh"
                        if(_parent._left == NULL)
                        {
                            _parent._left = tmp_ptr;

                            tmp_ptr._left = NULL;
                            tmp_ptr._right = NULL;
                            _root = _remove_fixup(_root);
                            _parent._left = NULL;
                        }

                        else if(_parent._right == NULL)
                        {
                            tmp_ptr._parent = (_left != NULL) ? _left : _parent;
                            _parent._right = tmp_ptr;
                            tmp_ptr._left = NULL;
                            tmp_ptr._right = NULL;
                            _root = _remove_fixup(_root);
                            _parent._right = NULL;
                        }

                        else if( (_parent._right == _right)
                              || (_left._right == _right)
                              || (right_double_red) )
                        { _root = ((_object_rb_t_node<USER_DATA>*)_right)._remove_fixup(_root); }

                        else
                        { _root = ((_object_rb_t_node<USER_DATA>*)_parent._left)._remove_fixup(_root); }
                    }


                    else if( (_right != NULL)
                          && ((_state + this_state) == 1)
                          && ((_state + ((_object_rb_t_node<USER_DATA>*)_right)._state) == 1) )
                    { ((_object_rb_t_node<USER_DATA>*)_right)._state = NULL; }


                    _root._state = NULL;


                    _left = (do_not_delete) ? _left : NULL;
                    _right = (do_not_delete) ? _right : NULL;
                    _parent = (do_not_delete) ? _parent : NULL;
                    _state = (do_not_delete) ? _state : 1;


                    return(_root);
                };





                void operator=(const _object_rb_t_node<USER_DATA>& p_in)
                {
                    remove((_object_rb_t_node<USER_DATA>*)_parent);
                    _object_binary_t_node<USER_DATA>::operator=((_object_binary_t_node<USER_DATA>)p_in);
                    _state = p_in._state;
                };


                void operator=(_object_rb_t_node<USER_DATA>* p_in)
                {
                    remove((_object_rb_t_node<USER_DATA>*)_parent);
                    _object_binary_t_node<USER_DATA>::operator=((_object_binary_t_node<USER_DATA>*)p_in);
                    _state = p_in._state;
                };


            private:



                _object_rb_t_node<USER_DATA>* _insert_fixup(_object_rb_t_node<USER_DATA>* _root)
                {
                    _object_rb_t_node<USER_DATA>* new_node = ::GetPointer(this);
                    _object_rb_t_node<USER_DATA>* uncle = NULL;
                    bool uncle_red = false;
                    bool uncle_left = false;
                    bool sibling = false;


                    while( (new_node != _root)
                        && (((_object_rb_t_node<USER_DATA>*)new_node._parent)._state != NULL)
                        && (!_StopFlag) )
                    {
                        uncle_left = (new_node._parent == new_node._parent._parent._left);
                        uncle = (uncle_left) ? new_node._parent._parent._right : new_node._parent._parent._left;
                        uncle_red = (uncle != NULL) && (uncle._state != NULL);
                        sibling = (uncle_left) ? (new_node == new_node._parent._right) : (new_node == new_node._parent._left);

                        if(uncle_red)
                        { uncle._state = NULL; }
                        new_node = (!uncle_red) && (sibling) ? new_node._parent : new_node;
                        _root = (!uncle_red) && (sibling) ? ((uncle_left) ? _left_rotate(new_node, _root) : _right_rotate(new_node, _root)) : _root;
                        ((_object_rb_t_node<USER_DATA>*)new_node._parent)._state = NULL;
                        ((_object_rb_t_node<USER_DATA>*)new_node._parent._parent)._state = 1;
                        new_node = (uncle_red) ? new_node._parent._parent : new_node;
                        _root = (!uncle_red) ? ((uncle_left) ? _right_rotate(new_node._parent._parent, _root) : _left_rotate(new_node._parent._parent, _root)) : _root;
                    }


                    _root._state = NULL;


                    return(_root);
                };


                _object_rb_t_node<USER_DATA>* _remove_fixup(_object_rb_t_node<USER_DATA>* _root)
                {

                    bool fixup_left = false;
                    bool sibling_red = false;
                    bool sibling_children_black = false;
                    bool other_child_black = false;
                    _object_rb_t_node<USER_DATA>* sibling = NULL;
                    _object_rb_t_node<USER_DATA>* sibling_this_child = NULL;
                    _object_rb_t_node<USER_DATA>* sibling_other_child = NULL;
                    _object_rb_t_node<USER_DATA>* fixup_node = ::GetPointer(this);


                    while( (fixup_node != _root)
                        && (fixup_node._state == NULL)
                        && (!_StopFlag) )
                    {
                        if(fixup_node == fixup_node._parent._left)
                        {
                            sibling = fixup_node._parent._right;
                            if( (sibling != NULL)
                             && (sibling._state != NULL) )
                            {
                                ((_object_rb_t_node<USER_DATA>*)fixup_node._parent)._state = 1;
                                sibling._state = NULL;
                                _root = _left_rotate(fixup_node._parent, _root);
                                sibling = fixup_node._parent._right;
                            }

                            if(sibling == NULL)
                            { return(_root); }

                            if( ( (sibling._left == NULL)
                               || (((_object_rb_t_node<USER_DATA>*)sibling._left)._state == NULL))
                             && ( (sibling._right == NULL)
                               || (((_object_rb_t_node<USER_DATA>*)sibling._right)._state == NULL)) )
                            {
                                sibling._state = 1;
                                fixup_node = fixup_node._parent;
                            }
                            else
                            {
                                if( (sibling._right == NULL)
                                 || (((_object_rb_t_node<USER_DATA>*)sibling._right)._state == NULL) )
                                {
                                    if(sibling._left != NULL)
                                    { ((_object_rb_t_node<USER_DATA>*)sibling._left)._state = NULL; }
                                    sibling._state = 1;
                                    _root = _right_rotate(sibling, _root);
                                    sibling = fixup_node._parent._right;
                                }

                                sibling._state = (fixup_node._parent != NULL) ? ((_object_rb_t_node<USER_DATA>*)fixup_node._parent)._state : NULL;
                                if(fixup_node._parent != NULL)
                                { ((_object_rb_t_node<USER_DATA>*)fixup_node._parent)._state = NULL; }
                                if(sibling._right != NULL)
                                { ((_object_rb_t_node<USER_DATA>*)sibling._right)._state = NULL; }
                                _root = _left_rotate(fixup_node._parent, _root);
                                fixup_node = _root;
                            }
                        }
                        else
                        {
                            sibling = fixup_node._parent._left;
                            if( (sibling != NULL)
                             && (sibling._state != NULL) )
                            {
                                ((_object_rb_t_node<USER_DATA>*)fixup_node._parent)._state = 1;
                                sibling._state = NULL;
                                _root = _right_rotate(fixup_node._parent, _root);
                                sibling = fixup_node._parent._left;
                            }

                            if(sibling == NULL)
                            { return(_root); }

                            if( ( (sibling._right == NULL)
                               || (((_object_rb_t_node<USER_DATA>*)sibling._right)._state == NULL))
                             && ( (sibling._left == NULL)
                               || (((_object_rb_t_node<USER_DATA>*)sibling._left)._state == NULL)) )
                            {
                                sibling._state = 1;
                                fixup_node = fixup_node._parent;
                            }
                            else
                            {
                                if( (sibling._left == NULL)
                                 || (((_object_rb_t_node<USER_DATA>*)sibling._left)._state == NULL) )
                                {
                                    if(sibling._right != NULL)
                                    { ((_object_rb_t_node<USER_DATA>*)sibling._right)._state = NULL; }
                                    sibling._state = 1;
                                    _root = _left_rotate(sibling, _root);
                                    sibling = fixup_node._parent._left;
                                }
                                sibling._state = (fixup_node._parent != NULL) ? ((_object_rb_t_node<USER_DATA>*)fixup_node._parent)._state : NULL;
                                if(fixup_node._parent != NULL)
                                { ((_object_rb_t_node<USER_DATA>*)fixup_node._parent)._state = NULL; }
                                if(sibling._left != NULL)
                                { ((_object_rb_t_node<USER_DATA>*)sibling._left)._state = NULL; }
                                _root = _right_rotate(fixup_node._parent, _root);
                                fixup_node = _root;
                            }
                        }
                    }


                    fixup_node._state = NULL;
                    _root._parent = NULL;


                    return(_root);
                };


                _object_rb_t_node<USER_DATA>* _left_rotate(_object_rb_t_node<USER_DATA>* x, _object_rb_t_node<USER_DATA>* _root)
                {

                    _object_rb_t_node<USER_DATA>* y = x._right;


                    x._right = (x._right != NULL) ? x._right._left : NULL;

                    if(y._left != NULL)
                    { y._left._parent = x; }
                    y._parent = x._parent;

                    if(x._parent == NULL)
                    {
                        _root = y;
                        y._left = x;
                        x._parent = y;
                        _root._parent = NULL;
                        return(_root);
                    }
                    else
                    {
                        x._parent._left = (x == x._parent._left) ? y : x._parent._left;
                        x._parent._right = (x == x._parent._right) ? y : x._parent._right;
                    }
                    y._left = x;
                    x._parent = y;


                    return(_root);
                };


                _object_rb_t_node<USER_DATA>* _right_rotate(_object_rb_t_node<USER_DATA>* x, _object_rb_t_node<USER_DATA>* _root)
                {

                    _object_rb_t_node<USER_DATA>* y = x._left;


                    x._left = (x._left != NULL) ? x._left._right : NULL;

                    if(y._right != NULL)
                    { y._right._parent = x; }
                    y._parent = x._parent;

                    if(x._parent == NULL)
                    {
                        _root = y;
                        y._right = x;
                        x._parent = y;
                        _root._parent = NULL;
                        return(_root);
                    }
                    else
                    {
                        x._parent._right = (x == x._parent._right) ? y : x._parent._right;
                        x._parent._left = (x == x._parent._left) ? y : x._parent._left;
                    }
                    y._right = x;
                    x._parent = y;


                    return(_root);
                };


            public:


                const string _node_to_string(int& count)
                { count++; return(StringFormat("Parent Value: %s; Color: %s; Value: %s", (_parent != NULL) ? __obj_to_string(_parent.this_obj) : "Root-Node", (_state == NULL) ? "Black" : "Red", __obj_to_string(this_obj))); };
        };
//# 32 "lib_structures/nodes/lib_obj_node_tree_rb.mqh" 2
//# 56 "lib_structures/nodes/lib_obj_node_tree_rb.mqh"
        template <typename USER_DATA>
        class object_rb_tree_node : public _object_typecast_tree_node<USER_DATA, _object_rb_t_node<USER_DATA>, object_rb_tree_node<USER_DATA> >
        {
            public:



                object_rb_tree_node() : _object_typecast_tree_node<USER_DATA, _object_rb_t_node<USER_DATA>, object_rb_tree_node<USER_DATA> >() { };


                object_rb_tree_node(const object_rb_tree_node<USER_DATA>& p_in) { _object_typecast_tree_node<USER_DATA, _object_rb_t_node<USER_DATA>, object_rb_tree_node<USER_DATA> >(p_in); };


                template <typename CUSTOM_DATA>
                object_rb_tree_node(CUSTOM_DATA* p_in, int& valid_data) { valid_data = _autocreate(p_in); };
                template <typename CUSTOM_DATA>
                object_rb_tree_node(CUSTOM_DATA& p_in, int& valid_data) { valid_data = _autocreate(p_in); };
                object_rb_tree_node(USER_DATA& p_in, int& valid_data) { valid_data = true; this_obj = p_in; };


                ~object_rb_tree_node() { };





                object_rb_tree_node<USER_DATA>* root_element() { return((object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA>::root()); };


                object_rb_tree_node<USER_DATA>* lowest_element() { return((object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA>::left()); };


                object_rb_tree_node<USER_DATA>* highest_element() { return((object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA>::right()); };


                object_rb_tree_node<USER_DATA>* parent_element() { return((object_rb_tree_node<USER_DATA>*)_parent); };


                object_rb_tree_node<USER_DATA>* left_element() { return((object_rb_tree_node<USER_DATA>*)_left); };


                object_rb_tree_node<USER_DATA>* right_element() { return((object_rb_tree_node<USER_DATA>*)_right); };


                template <typename UNIFIED>
                object_rb_tree_node<USER_DATA>* next_smaller_element(UNIFIED* p_in, const bool or_equal = false) { return((object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA>::smaller(p_in, or_equal)); };
                object_rb_tree_node<USER_DATA>* next_smaller_element(USER_DATA& p_in, const bool or_equal = false) { return((object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA>::smaller(p_in, or_equal)); };


                template <typename UNIFIED>
                object_rb_tree_node<USER_DATA>* next_greater_element(UNIFIED* p_in, const bool or_equal = false) { return((object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA>::greater(p_in, or_equal)); };
                object_rb_tree_node<USER_DATA>* next_greater_element(USER_DATA& p_in, const bool or_equal = false) { return((object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA>::greater(p_in, or_equal)); };





                object_rb_tree_node<USER_DATA>* insert(object_rb_tree_node<USER_DATA>* p_root) { return((object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA>::insert(p_root)); };


                USER_DATA get_key() const { return(this_obj); };


                USER_DATA get_obj() const { return(this_obj); };


                USER_DATA detach_obj() { return(this_obj); };


                object_rb_tree_node<USER_DATA>* remove(object_rb_tree_node<USER_DATA>* p_root, const bool do_not_delete = false) { return((object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA>::remove(p_root)); };


                object_rb_tree_node<USER_DATA>* smallest_node() { return((object_rb_tree_node<USER_DATA>*)_object_binary_t_node<USER_DATA>::_subtree_smallest_key((_parent != NULL) ? _parent : (_object_binary_t_node<USER_DATA>*)::GetPointer(this))); }


                object_rb_tree_node<USER_DATA>* greatest_node() { return((object_rb_tree_node<USER_DATA>*)_object_binary_t_node<USER_DATA>::_subtree_greatest_key((_parent != NULL) ? _parent : (_object_binary_t_node<USER_DATA>*)::GetPointer(this))); }





                template <typename UNIFIED>
                USER_DATA operator=(const UNIFIED* p_in) { this_obj = p_in; return(this_obj); };
                USER_DATA operator=(USER_DATA& p_in) { this_obj = p_in; return(this_obj); };


                template <typename UNIFIED>
                object_rb_tree_node<USER_DATA>* operator[](UNIFIED* p_in) { return((object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA>::operator[](p_in)); };
                object_rb_tree_node<USER_DATA>* operator[](USER_DATA& p_in) { return((object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA>::operator[](p_in)); };


                void operator=(const object_rb_tree_node<USER_DATA>& p_in) { _object_rb_t_node<USER_DATA>::operator=((_object_rb_t_node<USER_DATA>)p_in); };


                const bool operator>(object_rb_tree_node<USER_DATA>* p_in) const { return(this_obj > p_in.this_obj); };
                template <typename CUSTOM_DATA>
                const bool operator>(CUSTOM_DATA* p_in) const { return(_cast_compare_operator_greater(p_in)); };
                template <typename CUSTOM_DATA>
                const bool operator>(CUSTOM_DATA& p_in) const { return(_cast_compare_operator_greater(p_in)); };
                const bool operator>(const USER_DATA& p_in) const { return(this_obj > p_in); };

                const bool operator<(object_rb_tree_node<USER_DATA>* p_in) const { return(p_in.this_obj > this_obj); };
                template <typename CUSTOM_DATA>
                const bool operator<(CUSTOM_DATA* p_in) const { return(_cast_compare_operator_smaller(p_in)); };
                template <typename CUSTOM_DATA>
                const bool operator<(CUSTOM_DATA& p_in) const { return(_cast_compare_operator_smaller(p_in)); };
                const bool operator<(const USER_DATA& p_in) const { return(p_in > this_obj); };




                const uchar _node_color() { return(this._state); };
                const bool _node_isleaf() { return((left_element() == NULL) && (right_element() == NULL)); };
                const string _node_to_string(int& count) { return(_object_rb_t_node<USER_DATA>::_node_to_string(count)); };
        };
//# 185 "lib_structures/nodes/lib_obj_node_tree_rb.mqh"
        template <typename USER_DATA>
        class ptr_object_rb_tree_node : public _object_typecast_tree_node<USER_DATA*, _object_rb_t_node<USER_DATA*>, NODE_TYPE>
        {
            public:



                ptr_object_rb_tree_node() : _object_typecast_tree_node<USER_DATA*, _object_rb_t_node<USER_DATA*>, NODE_TYPE>() { };


                ptr_object_rb_tree_node(const ptr_object_rb_tree_node<USER_DATA>& p_in) { _object_typecast_tree_node<USER_DATA*, _object_rb_t_node<USER_DATA*>, NODE_TYPE>(p_in); };


                template <typename CUSTOM_DATA>
                ptr_object_rb_tree_node(const CUSTOM_DATA* p_in, int& valid_data) { valid_data = _autocreate(p_in); };
                template <typename CUSTOM_DATA>
                ptr_object_rb_tree_node(CUSTOM_DATA* p_in, int& valid_data) { valid_data = 2; this_obj = p_in; };
                template <typename CUSTOM_DATA>
                ptr_object_rb_tree_node(CUSTOM_DATA& p_in, int& valid_data) { valid_data = _autocreate(p_in); };
                ptr_object_rb_tree_node(USER_DATA& p_in, int& valid_data) { valid_data = _autocreate(p_in); };
                ptr_object_rb_tree_node(USER_DATA* p_in, int& valid_data) { valid_data = (CheckPointer(p_in) == POINTER_INVALID) ? NULL : 2; this_obj = p_in; };
                ptr_object_rb_tree_node(const USER_DATA* p_in, int& valid_data) { valid_data = NULL; if(CheckPointer(p_in) != POINTER_INVALID) { valid_data = 2; this_obj = (USER_DATA*)p_in; } };


                ~ptr_object_rb_tree_node() { if((this_obj != NULL) && (CheckPointer(this_obj) == POINTER_DYNAMIC)) { delete(this_obj); this_obj = NULL; } };





                ptr_object_rb_tree_node<USER_DATA>* root_element() { return((ptr_object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA*>::root()); };


                ptr_object_rb_tree_node<USER_DATA>* lowest_element() { return((ptr_object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA*>::left()); };


                ptr_object_rb_tree_node<USER_DATA>* highest_element() { return((ptr_object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA*>::right()); };


                ptr_object_rb_tree_node<USER_DATA>* parent_element() { return((ptr_object_rb_tree_node<USER_DATA>*)_parent); };


                ptr_object_rb_tree_node<USER_DATA>* left_element() { return((ptr_object_rb_tree_node<USER_DATA>*)_left); };


                ptr_object_rb_tree_node<USER_DATA>* right_element() { return((ptr_object_rb_tree_node<USER_DATA>*)_right); };


                template <typename UNIFIED>
                ptr_object_rb_tree_node<USER_DATA>* next_smaller_element(UNIFIED* p_in, const bool or_equal = false) { return((ptr_object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA*>::smaller(p_in, or_equal)); };
                ptr_object_rb_tree_node<USER_DATA>* next_smaller_element(USER_DATA& p_in, const bool or_equal = false) { return((ptr_object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA*>::smaller(p_in, or_equal)); };


                template <typename UNIFIED>
                ptr_object_rb_tree_node<USER_DATA>* next_greater_element(UNIFIED* p_in, const bool or_equal = false) { return((ptr_object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA*>::greater(p_in, or_equal)); };
                ptr_object_rb_tree_node<USER_DATA>* next_greater_element(USER_DATA& p_in, const bool or_equal = false) { return((ptr_object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA*>::greater(p_in, or_equal)); };





                ptr_object_rb_tree_node<USER_DATA>* insert(ptr_object_rb_tree_node<USER_DATA>* p_root) { return((ptr_object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA*>::insert(p_root)); };


                USER_DATA* get_key() const { return(this_obj); };


                USER_DATA* get_obj() const { return(this_obj); };


                USER_DATA* detach_obj() { USER_DATA* p_tmp = this_obj; this_obj = NULL; return(p_tmp); };


                ptr_object_rb_tree_node<USER_DATA>* remove(ptr_object_rb_tree_node<USER_DATA>* p_root, const bool do_not_delete = false) { return((ptr_object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA*>::remove(p_root)); };


                ptr_object_rb_tree_node<USER_DATA>* smallest_node() { return((ptr_object_rb_tree_node<USER_DATA>*)_object_binary_t_node<USER_DATA*>::_subtree_smallest_key((_parent != NULL) ? _parent : (_object_binary_t_node<USER_DATA*>*)::GetPointer(this))); }


                ptr_object_rb_tree_node<USER_DATA>* greatest_node() { return((ptr_object_rb_tree_node<USER_DATA>*)_object_binary_t_node<USER_DATA*>::_subtree_greatest_key((_parent != NULL) ? _parent : (_object_binary_t_node<USER_DATA*>*)::GetPointer(this))); }





                template <typename UNIFIED>
                const USER_DATA* operator=(const UNIFIED* p_in) { this_obj = p_in; return(this_obj); };
                const USER_DATA* operator=(USER_DATA*& p_in) { this_obj = p_in; return(this_obj); };


                template <typename UNIFIED>
                ptr_object_rb_tree_node<USER_DATA>* operator[](UNIFIED* p_in) { return((CheckPointer(p_in) == POINTER_INVALID) ? NULL : (ptr_object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA*>::operator[](p_in)); };
                ptr_object_rb_tree_node<USER_DATA>* operator[](USER_DATA*& p_in) { return((CheckPointer(p_in) == POINTER_INVALID) ? NULL : (ptr_object_rb_tree_node<USER_DATA>*)_object_rb_t_node<USER_DATA*>::operator[](p_in)); };


                void operator=(const ptr_object_rb_tree_node<USER_DATA>& p_in) { _object_rb_t_node<USER_DATA*>::operator=((_object_rb_t_node<USER_DATA*>)p_in); };


                const bool operator>(ptr_object_rb_tree_node<USER_DATA>* p_in) const { return(this_obj > p_in.this_obj); };
                template <typename CUSTOM_DATA>
                const bool operator>(CUSTOM_DATA* p_in) const { return((CheckPointer(p_in) == POINTER_INVALID) ? true : _cast_compare_operator_greater(p_in)); };
                template <typename CUSTOM_DATA>
                const bool operator>(CUSTOM_DATA& p_in) const { return(_cast_compare_operator_greater(p_in)); };
                const bool operator>(const USER_DATA*& p_in) const { return(this_obj > p_in); };

                const bool operator<(ptr_object_rb_tree_node<USER_DATA>* p_in) const { return(p_in.this_obj > this_obj); };
                template <typename CUSTOM_DATA>
                const bool operator<(CUSTOM_DATA* p_in) const { return((CheckPointer(p_in) == POINTER_INVALID) ? false : _cast_compare_operator_smaller(p_in)); };
                template <typename CUSTOM_DATA>
                const bool operator<(CUSTOM_DATA& p_in) const { return(_cast_compare_operator_smaller(p_in)); };
                const bool operator<(const USER_DATA*& p_in) const { return(p_in > this_obj); };




                const uchar _node_color() { return(this._state); };
                const bool _node_isleaf() { return((left_element() == NULL) && (right_element() == NULL)); };
                const string _node_to_string(int& count) { return(_object_rb_t_node<USER_DATA*>::_node_to_string(count)); };
        };
//# 32 "lib_structures/lib_tree.mqh" 2
//# 1 "lib_structures/base/lib_base_tree.mqh" 1
//# 31 "lib_structures/base/lib_base_tree.mqh"
//# 1 "lib_structures/base/lib_base_node_element.mqh" 1
//# 44 "lib_structures/base/lib_base_node_element.mqh"
        template <typename NODE_TYPE>
        class _param_details
        {
            public:

            NODE_TYPE* p_root;
            NODE_TYPE* p_left;
            NODE_TYPE* p_right;
            NODE_TYPE* p_last_added;
            int _size;
            int instance_cnt;
            bool do_not_destroy;


            _param_details(const bool _do_not_destroy = false) :
                p_root (NULL),
                p_left (NULL),
                p_right (NULL),
                p_last_added (NULL),
                _size (NULL),
                instance_cnt (1),
                do_not_destroy (_do_not_destroy)
            { };


            void clear(const bool _delete = false)
            {
                instance_cnt--;
                if(instance_cnt == NULL)
                {
                    p_root = NULL;
                    p_left = NULL;
                    p_right = NULL;
                    p_last_added = NULL;
                    _size = NULL;
                    do_not_destroy = false;
                }
                instance_cnt += (instance_cnt == NULL) && !_delete;
            };
        };
//# 94 "lib_structures/base/lib_base_node_element.mqh"
        template <typename PARAM_TYPE, typename NODE_TYPE>
        class _abs_element
        {
            protected:


                PARAM_TYPE* p_params;
                NODE_TYPE* p_element_obj;


            public:


                _abs_element() :
                    p_params (NULL),
                    p_element_obj (NULL)
                { };

                _abs_element(NODE_TYPE* p_obj, PARAM_TYPE* p_in) :
                    p_params (p_in),
                    p_element_obj (p_obj)
                { };

                _abs_element(const _abs_element& p_in) :
                    p_params (p_in.p_params),
                    p_element_obj (p_in.p_element_obj)
                { };




                const bool init(NODE_TYPE* p_obj, PARAM_TYPE* p_in_params)
                {
                    p_element_obj = (p_element_obj == NULL) ? p_obj : p_element_obj;
                    p_params = (p_params == NULL) ? p_in_params : p_params;
                    return((p_element_obj == p_obj) && (p_params != NULL));
                }

                const bool set(NODE_TYPE* p_obj)
                {
                    p_element_obj = p_obj;
                    return(p_element_obj != NULL);
                };

                void reset()
                {
                    p_element_obj = NULL;
                    p_params = NULL;
                };

                const bool clear()
                {
                    p_element_obj = NULL;
                    return(p_params != NULL);
                };
        };






        template <typename PARAM_TYPE, typename NODE_TYPE, typename USER_DATA, typename PAYLOAD_TYPE>
        class _element : public _abs_element<PARAM_TYPE, NODE_TYPE>
        {
            protected:


                _element() : _abs_element<PARAM_TYPE, NODE_TYPE>() { };
                _element(NODE_TYPE* p_obj, PARAM_TYPE* p_param) : _abs_element<PARAM_TYPE, NODE_TYPE>(p_obj, p_param) { };
                _element(const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>& p_in) : _abs_element<PARAM_TYPE, NODE_TYPE>(p_in) { };


            public:


                                                void operator=(const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>* p_in) { p_params = p_in.p_params; p_element_obj = p_in.p_element_obj; };
                                                void operator=(const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>& p_in) { p_params = p_in.p_params; p_element_obj = p_in.p_element_obj; };


                template <typename CUSTOM_DATA> USER_DATA operator=(CUSTOM_DATA* p_in) { return(key(p_in)); };
                template <typename CUSTOM_DATA> USER_DATA operator=(const CUSTOM_DATA* p_in) { return(key(p_in)); };
                template <typename CUSTOM_DATA> USER_DATA operator=(CUSTOM_DATA& p_in) { return(key(p_in)); };
                template <typename CUSTOM_DATA> USER_DATA operator=(CUSTOM_DATA p_in) { return(key(p_in)); };
                                                USER_DATA operator=(const USER_DATA& p_in) { return(key(p_in)); };
                                                USER_DATA operator=(USER_DATA& p_in) { return(key(p_in)); };






                                                const bool operator!=(const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>& p_in) const { return( (!_element_valid(p_in)) ? !(p_element_obj == p_in.p_element_obj) : ((p_element_obj > p_in.p_element_obj) || (p_in.p_element_obj > p_element_obj)) ); };
                                                const bool operator==(const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>& p_in) const { return( !operator!=(p_in) ); };
                                                const bool operator>=(const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>& p_in) const { return( (_element_valid(p_in)) && !(p_in.p_element_obj > p_element_obj) ); };
                                                const bool operator<=(const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>& p_in) const { return( (_element_valid(p_in)) && !(p_element_obj > p_in.p_element_obj) ); };
                                                const bool operator> (const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>& p_in) const { return( (_element_valid(p_in)) && (p_element_obj > p_in.p_element_obj) ); };
                                                const bool operator< (const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>& p_in) const { return( (_element_valid(p_in)) && (p_in.p_element_obj > p_element_obj) ); };

                                                const bool operator!=(const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>* p_in) const {
                                                                                                                                                        const int tmp = _element_valid(p_in);
                                                                                                                                                        switch(_element_valid(p_in))
                                                                                                                                                        {
                                                                                                                                                            case 7: return( (p_element_obj != p_in.p_element_obj)
                                                                                                                                                                         && ((p_element_obj > p_in.p_element_obj) || (p_in.p_element_obj > p_element_obj)) );
                                                                                                                                                            case 6: return(p_in != GetPointer(this));
                                                                                                                                                            case 4:
                                                                                                                                                            case 0: return(p_element_obj != NULL);
                                                                                                                                                        }
                                                                                                                                                        return(true);
                                                                                                                                                    };
                                                const bool operator==(const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>* p_in) const { return( !operator!=(p_in) ); };
                                                const bool operator>=(const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>* p_in) const { return( (_element_valid(p_in)) && !(p_in.p_element_obj > p_element_obj) ); };
                                                const bool operator<=(const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>* p_in) const { return( (_element_valid(p_in)) && !(p_element_obj > p_in.p_element_obj) ); };
                                                const bool operator> (const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>* p_in) const { return( (_element_valid(p_in)) && (p_element_obj > p_in.p_element_obj) ); };
                                                const bool operator< (const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>* p_in) const { return( (_element_valid(p_in)) && (p_in.p_element_obj > p_element_obj) ); };

                template <typename CUSTOM_DATA> const bool operator!=(CUSTOM_DATA p_in) const { return( (!_element_valid()) || (p_element_obj > p_in) || (p_element_obj < p_in) ); };
                template <typename CUSTOM_DATA> const bool operator!=(const CUSTOM_DATA& p_in) const { return( (!_element_valid()) || (p_element_obj > p_in) || (p_element_obj < p_in) ); };
                                                const bool operator!=(const USER_DATA& p_in) const { return( (!_element_valid()) || (p_element_obj > p_in) || (p_element_obj < p_in) ); };

                template <typename CUSTOM_DATA> const bool operator==(CUSTOM_DATA p_in) const { return( !operator!=(p_in) ); };
                template <typename CUSTOM_DATA> const bool operator==(const CUSTOM_DATA& p_in) const { return( !operator!=(p_in) ); };
                                                const bool operator==(const USER_DATA& p_in) const { return( !operator!=(p_in) ); };

                template <typename CUSTOM_DATA> const bool operator>=(CUSTOM_DATA p_in) const { return( (_element_valid()) && !(p_element_obj < p_in) ); };
                template <typename CUSTOM_DATA> const bool operator>=(const CUSTOM_DATA& p_in) const { return( (_element_valid()) && !(p_element_obj < p_in) ); };
                                                const bool operator>=(const USER_DATA& p_in) const { return( (_element_valid()) && !(p_element_obj < p_in) ); };

                template <typename CUSTOM_DATA> const bool operator<=(CUSTOM_DATA p_in) const { return( (_element_valid()) && !(p_element_obj > p_in) ); };
                template <typename CUSTOM_DATA> const bool operator<=(const CUSTOM_DATA& p_in) const { return( (_element_valid()) && !(p_element_obj > p_in) ); };
                                                const bool operator<=(const USER_DATA& p_in) const { return( (_element_valid()) && !(p_element_obj > p_in) ); };

                template <typename CUSTOM_DATA> const bool operator> (CUSTOM_DATA p_in) const { return( (_element_valid()) && (p_element_obj > p_in) ); };
                template <typename CUSTOM_DATA> const bool operator> (const CUSTOM_DATA& p_in) const { return( (_element_valid()) && (p_element_obj > p_in) ); };
                                                const bool operator> (const USER_DATA& p_in) const { return( (_element_valid()) && (p_element_obj > p_in) ); };

                template <typename CUSTOM_DATA> const bool operator< (CUSTOM_DATA p_in) const { return( (_element_valid()) && (p_element_obj < p_in) ); };
                template <typename CUSTOM_DATA> const bool operator< (const CUSTOM_DATA& p_in) const { return( (_element_valid()) && (p_element_obj < p_in) ); };
                                                const bool operator< (const USER_DATA& p_in) const { return( (_element_valid()) && (p_element_obj < p_in) ); };




                                                const bool remove(const bool _do_not_destroy = false) { return(_remove(_do_not_destroy, true)); };



                template <typename CUSTOM_DATA> const bool set(const CUSTOM_DATA* p_in) { int valid_data = _element_valid(); if(operator==(p_in)) { return((valid_data) ? true : _set(p_element_obj)); } if( (!valid_data) && (p_element_obj == NULL) ) { return(false); } NODE_TYPE* p_node = new NODE_TYPE(p_in, valid_data); if( !(valid_data) || ((valid_data) && !_set(p_node)) ) { if(valid_data == 2) { p_node.detach_obj(); } delete(p_node); return(false); } return(true); };
                template <typename CUSTOM_DATA> const bool set(CUSTOM_DATA& p_in) { int valid_data = _element_valid(); if(operator==(p_in)) { return((valid_data) ? true : _set(p_element_obj)); } if( (!valid_data) && (p_element_obj == NULL) ) { return(false); } NODE_TYPE* p_node = new NODE_TYPE(p_in, valid_data); if( (valid_data) && !_set(p_node) ) { if(valid_data == 2) { p_node.detach_obj(); } delete(p_node); return(false); } return(true); };
                template <typename CUSTOM_DATA> const bool set(CUSTOM_DATA p_in) { return(set(p_in)); };

                                                const bool set(const USER_DATA& p_in) { int valid_data = _element_valid(); if(operator==(p_in)) { return((valid_data) ? true : _set(p_element_obj)); } if( (!valid_data) && (p_element_obj == NULL) ) { return(false); } NODE_TYPE* p_node = new NODE_TYPE(p_in, valid_data); if( !(valid_data) || ((valid_data) && !_set(p_node)) ) { if(valid_data == 2) { p_node.detach_obj(); } delete(p_node); return(false); } return(true); };


                                                virtual USER_DATA key() const { if(p_element_obj == NULL) { USER_DATA tmp; ZeroMemory(tmp); return(tmp); } return(p_element_obj.get_key()); };

                template <typename CUSTOM_DATA> USER_DATA key(const CUSTOM_DATA* p_in) { if(set(p_in)) { return(p_element_obj.get_key()); } USER_DATA tmp; ZeroMemory(tmp); return(tmp); };
                template <typename CUSTOM_DATA> USER_DATA key(CUSTOM_DATA& p_in) { if(set(p_in)) { return(p_element_obj.get_key()); } USER_DATA tmp; ZeroMemory(tmp); return(tmp); };
                template <typename CUSTOM_DATA> USER_DATA key(CUSTOM_DATA p_in) { if(set(p_in)) { return(p_element_obj.get_key()); } USER_DATA tmp; ZeroMemory(tmp); return(tmp); };
                                                USER_DATA key(const USER_DATA& p_in) { if(set(p_in)) { return(p_element_obj.get_key()); } USER_DATA tmp; ZeroMemory(tmp); return(tmp); };

                                                virtual PAYLOAD_TYPE get() const = 0;
                protected: virtual const bool _set(NODE_TYPE* _replace, const bool _do_not_destroy = false) = 0;
                protected: virtual const bool _remove(const bool _do_not_destroy = false, const bool _destroy_node = true) = 0;
                protected: virtual const bool _element_valid() const { return(p_element_obj != NULL); };
                protected: const bool _element_valid(const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>& p_in) const { return((p_element_obj != NULL) && (p_in.p_element_obj != NULL)); };
                protected: const int _element_valid(const _element<PARAM_TYPE, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>* p_in) const { return(((p_in != NULL) ? 2 + (p_in.p_element_obj != NULL) : 0) + ((p_element_obj != NULL) ? 4 : 0)); };
        };
//# 276 "lib_structures/base/lib_base_node_element.mqh"
        template <typename USER_DATA, typename PAYLOAD_TYPE, typename CONTAINER_TYPE, typename ELEMENT_TYPE, typename NODE_TYPE>
        class _iterator : public ELEMENT_TYPE
        {
            public:


                NODE_TYPE* p_tmp_replaced;
                ELEMENT_TYPE p_list[];
                bool is_deleted[];
                bool dnd_element[];
                int iter_size;
                int p_cnt;
                bool have_deletes;


            public:


                _iterator() :
                    p_tmp_replaced(NULL), iter_size(NULL), p_cnt(-1), have_deletes(false) { };

                _iterator(ELEMENT_TYPE*& p_in[], const int _first = NULL, const int count = WHOLE_ARRAY) :
                    iter_size(NULL), p_cnt(-1), have_deletes(false) { init(p_in, _first, (count != WHOLE_ARRAY) ? (_first + count) : count); };

                _iterator(ELEMENT_TYPE& p_in[], const int _first = NULL, const int count = WHOLE_ARRAY) :
                    iter_size(NULL), p_cnt(-1), have_deletes(false) { init(p_in, _first, (count != WHOLE_ARRAY) ? (_first + count) : count); };

                _iterator(CONTAINER_TYPE& p_in) :
                    iter_size(NULL), p_cnt(-1), have_deletes(false) { init(p_in); };

                _iterator(_iterator& p_in) :
                    iter_size(p_in.iter_size), p_cnt(p_in.p_cnt), have_deletes(false) {
                                                                                                                                                        bool err = (ArrayResize(is_deleted, iter_size) != iter_size);
                                                                                                                                                        err |= (!err) && (ArrayResize(dnd_element, iter_size) != iter_size);
                                                                                                                                                        err |= (!err) && (ArrayResize(p_list, iter_size) != iter_size);
                                                                                                                                                        for(int cnt = NULL; (cnt < iter_size) && !_StopFlag && !err; cnt++)
                                                                                                                                                        { p_list[cnt].p_params = p_in.p_list[cnt].p_params; p_list[cnt].p_element_obj = p_in.p_list[cnt].p_element_obj; }
                                                                                                                                                    };




                ~_iterator() { _remove_deleted(!have_deletes); };




                const int size() { return(iter_size); }




                const bool operator=(ELEMENT_TYPE*& p_in[]) { return(init(p_in)); };
                const bool operator=(ELEMENT_TYPE& p_in[]) { return(init(p_in)); };
                const bool operator!() const { return((p_cnt == -1) && (iter_size == NULL)); };
                const int operator++(void) { return(next() ? p_cnt : -1); };
                const int operator--(void) { return(prev() ? p_cnt : -1); };
                const int operator++(int) { return(next() ? p_cnt : -1); };
                const int operator--(int) { return(prev() ? p_cnt : -1); };
                ELEMENT_TYPE* operator[](const int idx) const { return(((idx < NULL) || (idx >= iter_size)) ? NULL : GetPointer(p_list[idx])); };
                const bool operator=(CONTAINER_TYPE& p_in) { return(init(p_in)); };




                const bool init(ELEMENT_TYPE*& p_in[], const int _first = NULL, const int _last = WHOLE_ARRAY) { _remove_deleted(p_cnt == -1); iter_size = (_last == WHOLE_ARRAY) ? (ArraySize(p_in) - _first) : (_last - _first); for(int cnt = ArrayResize(p_list, iter_size) - 1; cnt > -1 && !_StopFlag; cnt--) { p_list[cnt].p_params = p_in[cnt].p_params; p_list[cnt].p_element_obj = p_in[cnt].p_element_obj; } return(_init()); };
                const bool init(ELEMENT_TYPE& p_in[], const int _first = NULL, const int _last = WHOLE_ARRAY) { _remove_deleted(p_cnt == -1); iter_size = (_last == WHOLE_ARRAY) ? (ArraySize(p_in) - _first) : (_last - _first); for(int cnt = ArrayResize(p_list, iter_size) - 1; cnt > -1 && !_StopFlag; cnt--) { p_list[cnt].p_params = p_in[cnt].p_params; p_list[cnt].p_element_obj = p_in[cnt].p_element_obj; } return(_init()); };
                const bool init(CONTAINER_TYPE& p_in) { _remove_deleted(p_cnt == -1); iter_size = p_in.get_array(p_list); return(_init()); };
                void reset() { p_cnt = -1; };
                const bool prev() {
                                                                                                                                                        p_tmp_replaced = NULL;
                                                                                                                                                        p_cnt = (p_cnt == -1) ? (iter_size - 1) : (p_cnt - 1);
                                                                                                                                                        const bool more_elements = _remove_deleted(p_cnt > -1);
                                                                                                                                                        p_element_obj = (more_elements) ? p_list[p_cnt].p_element_obj : NULL;
                                                                                                                                                        return(more_elements);
                                                                                                                                                    };
                const bool next() {
                                                                                                                                                        p_tmp_replaced = NULL;
                                                                                                                                                        p_cnt = (p_cnt == -1) ? NULL : (p_cnt + 1);
                                                                                                                                                        const bool more_elements = _remove_deleted(p_cnt < iter_size);
                                                                                                                                                        p_element_obj = (more_elements) ? p_list[p_cnt].p_element_obj : NULL;
                                                                                                                                                        return(more_elements);
                                                                                                                                                    };
                virtual const bool remove(const bool _do_not_destroy = false) {
                                                                                                                                                        if( (p_cnt == -1) || (is_deleted[p_cnt]) ) { return(false); }
                                                                                                                                                        is_deleted[p_cnt] |= ELEMENT_TYPE::_remove(true, false);
                                                                                                                                                        dnd_element[p_cnt] = _do_not_destroy || p_params.do_not_destroy;
                                                                                                                                                        have_deletes |= is_deleted[p_cnt];
                                                                                                                                                        return(is_deleted[p_cnt]);
                                                                                                                                                    };


            protected:


                const bool _init() {
                                                                                                                                                        bool err = (iter_size == NULL) || (ArrayResize(is_deleted, iter_size) != iter_size);
                                                                                                                                                        err |= (!err) && (ArrayResize(dnd_element, iter_size) != iter_size);
                                                                                                                                                        err |= (!err) && (ArrayInitialize(is_deleted, 0) != iter_size);
                                                                                                                                                        err |= (!err) && (ArrayInitialize(dnd_element, 0) != iter_size);
                                                                                                                                                        p_params = (!err) ? p_list[0].p_params : NULL;
                                                                                                                                                        return(!err);
                                                                                                                                                    };
                const bool _remove_deleted(const bool _is_valid) {
                                                                                                                                                        if(_is_valid) { return(true); }
                                                                                                                                                        for(int cnt = (have_deletes) ? NULL : iter_size; (cnt < iter_size); cnt++)
                                                                                                                                                        {
                                                                                                                                                            if(!is_deleted[cnt]) { continue; }
                                                                                                                                                            if(dnd_element[cnt]) { p_list[cnt].p_element_obj.detach_obj(); }
                                                                                                                                                            delete(p_list[cnt].p_element_obj);
                                                                                                                                                            p_list[cnt].p_element_obj = NULL;
                                                                                                                                                        }
                                                                                                                                                        ArrayFree(p_list);
                                                                                                                                                        ArrayFree(is_deleted);
                                                                                                                                                        ArrayFree(dnd_element);
                                                                                                                                                        p_cnt = -1;
                                                                                                                                                        iter_size = NULL;
                                                                                                                                                        p_element_obj = NULL;
                                                                                                                                                        p_params = NULL;
                                                                                                                                                        have_deletes = false;


                                                                                                                                                        return(false);
                                                                                                                                                    };
                virtual const bool _set(NODE_TYPE* _replace, const bool _do_not_destroy = false) {
                                                                                                                                                        if(p_cnt == -1) { return(false); }
                                                                                                                                                        bool result = false;
                                                                                                                                                        if( (p_element_obj == _replace)
                                                                                                                                                         && (is_deleted[p_cnt])
                                                                                                                                                         && (ELEMENT_TYPE::_insert(p_element_obj, true)) )
                                                                                                                                                        {
                                                                                                                                                            is_deleted[p_cnt] = false;
                                                                                                                                                            return(true);
                                                                                                                                                        }
                                                                                                                                                        else if( (is_deleted[p_cnt])
                                                                                                                                                              && (ELEMENT_TYPE::_insert(_replace, true)) )
                                                                                                                                                        {
                                                                                                                                                            is_deleted[p_cnt] = false;
                                                                                                                                                            if(dnd_element[p_cnt]) { p_list[p_cnt].p_element_obj.detach_obj(); }
                                                                                                                                                            delete(p_list[p_cnt].p_element_obj);
                                                                                                                                                            p_list[p_cnt].p_element_obj = _replace;
                                                                                                                                                            p_element_obj = _replace;
                                                                                                                                                            return(true);
                                                                                                                                                        }
                                                                                                                                                        else if(ELEMENT_TYPE::_set(_replace, true))
                                                                                                                                                        {
                                                                                                                                                            is_deleted[p_cnt] = true;
                                                                                                                                                            p_tmp_replaced = p_element_obj;
                                                                                                                                                            p_element_obj = _replace;
                                                                                                                                                            return(true);
                                                                                                                                                        }
                                                                                                                                                        return(false);
                                                                                                                                                    };
                virtual const bool _element_valid() const { return(!((is_deleted[p_cnt]) && (p_tmp_replaced == NULL))); };
        };
//# 441 "lib_structures/base/lib_base_node_element.mqh"
        template <typename USER_DATA, typename ELEMENT_TYPE, typename NODE_TYPE>
        class _obj_cast
        {
            public:

            _param_details<NODE_TYPE>* __p_params;


            _obj_cast(_param_details<NODE_TYPE>* p_params) : __p_params(p_params) { };


            template <typename ARRAY_TYPE>
            void cast_obj(ARRAY_TYPE& __p_arr[], NODE_TYPE* __p_this, const int __arr_ptr) const { __p_arr[__arr_ptr] = __p_this.get_obj(); }
            void cast_obj(ELEMENT_TYPE& __p_arr[], NODE_TYPE* __p_this, const int __arr_ptr) const { __p_arr[__arr_ptr].init(__p_this, __p_params); };
            void cast_obj(ELEMENT_TYPE*& __p_arr[], NODE_TYPE* __p_this, const int __arr_ptr) const { if(CheckPointer(__p_arr[__arr_ptr]) != POINTER_INVALID) { __p_arr[__arr_ptr].init(__p_this, __p_params); return; } __p_arr[__arr_ptr] = new ELEMENT_TYPE(__p_this, __p_params); };
        };
//# 468 "lib_structures/base/lib_base_node_element.mqh"
        template <typename USER_DATA, typename NODE_TYPE>
        struct _element_collection
        {
            protected:


                _param_details<NODE_TYPE>* p_params;
                _abs_element<_param_details<NODE_TYPE>, NODE_TYPE>* p_element;





                _element_collection(const bool _do_not_destroy = false) :
                    p_params (new _param_details<NODE_TYPE>(_do_not_destroy)),
                    p_element (NULL)
                { };


                _element_collection(const _element_collection<USER_DATA, NODE_TYPE>& p_in) :
                    p_params (p_in.p_params)
                { p_params.instance_cnt++; };


                _element_collection(_param_details<NODE_TYPE>* p_in) :
                    p_params (p_in)
                { p_params.instance_cnt++; };


                ~_element_collection()
                {
                    if( (CheckPointer(p_params) != POINTER_INVALID)
                     && (p_params.instance_cnt < 1) )
                    { delete(p_params); }
                    delete(p_element);
                };




                const bool _is_USER_DATA_ptr()
                { USER_DATA tmp; return(__is_ptr(tmp)); };


            private:


                template <typename CALL_TYPE>
                const bool __is_ptr(CALL_TYPE*& p_in) { return(true); }
                template <typename CALL_TYPE>
                const bool __is_ptr(CALL_TYPE& p_in) { return(false); }


            public:



                const int size() const
                { return(p_params._size); };


                NODE_TYPE* last_added_element()
                { return(p_params.p_last_added); };


                NODE_TYPE* first_element()
                { return(p_params.p_left); };


                NODE_TYPE* last_element()
                { return(p_params.p_right); };


                NODE_TYPE* root_element()
                { return(p_params.p_root); };





                void operator=(const _element_collection<USER_DATA, NODE_TYPE>& p_in)
                {

                    if(p_params.instance_cnt == NULL)
                    { delete(p_params); }


                    p_params = p_in.p_params;
                    p_params.instance_cnt++;
                };
        };
//# 32 "lib_structures/base/lib_base_tree.mqh" 2
//# 50 "lib_structures/base/lib_base_tree.mqh"
        template <typename USER_DATA, typename NODE_TYPE>
        struct _tree : public _element_collection<USER_DATA, NODE_TYPE>
        {
            protected:


                template <typename PAYLOAD_TYPE>
                class tree_element : public _element<_param_details<NODE_TYPE>, NODE_TYPE, USER_DATA, PAYLOAD_TYPE>
                {
                    public:


                        tree_element() : _element() { };
                        tree_element(NODE_TYPE* p_obj, _param_details<NODE_TYPE>* p_in) : _element(p_obj, p_in) { };
                        tree_element(const tree_element& p_in) : _element(p_in) { };


                    protected:


                        virtual const bool _set(NODE_TYPE* _replace, const bool _do_not_destroy = false)
                        {

                            if( (p_element_obj == NULL)
                             || (CheckPointer(p_params) == POINTER_INVALID) )
                            { return(false); }


                            NODE_TYPE* _root = _replace.insert(p_params.p_root);


                            if(_root == NULL)
                            {

                                return(false);
                            }


                            p_params.p_left = (_replace != p_element_obj) && (p_params.p_left == p_element_obj) ? p_params.p_left.parent_element() : p_params.p_left;
                            p_params.p_right = (_replace != p_element_obj) && (p_params.p_right == p_element_obj) ? p_params.p_right.parent_element() : p_params.p_right;

                            p_params.p_root = (_replace == p_element_obj) ? p_params.p_root : p_element_obj.remove(_root, p_params.do_not_destroy || _do_not_destroy);
                            p_params.p_left = (p_params.p_left == NULL) ? p_params.p_root : p_params.p_left;
                            p_params.p_right = (p_params.p_right == NULL) ? p_params.p_root : p_params.p_right;

                            while(p_params.p_left.left_element() != NULL) { p_params.p_left = p_params.p_left.left_element(); }
                            while(p_params.p_right.right_element() != NULL) { p_params.p_right = p_params.p_right.right_element(); }
                            if(!_do_not_destroy)
                            { delete(p_element_obj); }
                            p_element_obj = _replace;


                            p_params.p_left = (p_params.p_left > p_element_obj) ? p_element_obj : p_params.p_left;
                            p_params.p_right = (p_element_obj > p_params.p_right) ? p_element_obj : p_params.p_right;
                            p_params.p_last_added = p_element_obj;


                            return(true);
                        };

                        virtual const bool _insert(NODE_TYPE* p_new, const bool _do_not_destroy = false)
                        {
                            NODE_TYPE* _root = p_new.insert(p_params.p_root);
                            if(_root != NULL)
                            {

                                p_params.p_root = _root;
                                p_params.p_left = (p_params.p_left > p_new) ? p_new : p_params.p_left;
                                p_params.p_right = (p_new > p_params.p_right) ? p_new : p_params.p_right;
                                p_params.p_last_added = p_new;
                                p_params._size++;


                                return(true);
                            }
                            else if(!_do_not_destroy)
                            { delete(p_new); }


                            return(false);
                        };

                        virtual const bool _remove(const bool _do_not_destroy = false, const bool _destroy_node = true)
                        {
                            if((p_element_obj == NULL)
                             || (p_params._size == NULL)
                             || (CheckPointer(p_params) == POINTER_INVALID) )
                            { return(false); }


                            p_params.p_last_added = (p_params.p_last_added == p_element_obj) ? NULL : p_params.p_last_added;
                            NODE_TYPE* _edge = p_element_obj.parent_element();
                            NODE_TYPE* _root = p_element_obj.remove(p_params.p_root, p_params.do_not_destroy || _do_not_destroy || !_destroy_node);


                            p_params.p_root = (p_params._size == 1) ? NULL : ((_root != NULL) ? _root : p_params.p_root);


                            _edge = (_edge == NULL) ? p_params.p_root : _edge;
                            p_params.p_left = (p_params.p_left == p_element_obj) ? _edge : p_params.p_left;
                            p_params.p_right = (p_params.p_right == p_element_obj) ? _edge : p_params.p_right;
                            p_params._size--;


                            if(_destroy_node)
                            {
                                delete(p_element_obj);
                                p_element_obj = NULL;
                            }


                            return(true);
                        };
                };

            public:


                class element : public tree_element<USER_DATA>
                {
                    public:

                    element() : tree_element() { };
                    element(NODE_TYPE* p_obj, _param_details<NODE_TYPE>* p_in) : tree_element(p_obj, p_in) { };
                    element(const element& p_in) : tree_element(p_in) { };


                    virtual USER_DATA get() const { if(p_element_obj == NULL) { USER_DATA tmp; ZeroMemory(tmp); return(tmp); } return(p_element_obj.get_key()); };
                };





                class iterator final : public _iterator<USER_DATA, USER_DATA, _tree<USER_DATA, NODE_TYPE>, _tree<USER_DATA, NODE_TYPE>::element, NODE_TYPE>
                {
                    public:

                    iterator() : _iterator<USER_DATA, USER_DATA, _tree<USER_DATA, NODE_TYPE>, _tree<USER_DATA, NODE_TYPE>::element, NODE_TYPE>() { };
                    iterator(_tree<USER_DATA, NODE_TYPE>& p_in) : _iterator<USER_DATA, USER_DATA, _tree<USER_DATA, NODE_TYPE>, _tree<USER_DATA, NODE_TYPE>::element, NODE_TYPE>(p_in) { };
                    iterator(_tree<USER_DATA, NODE_TYPE>& p_in, USER_DATA& _first, USER_DATA& _last) : _iterator<USER_DATA, USER_DATA, _tree<USER_DATA, NODE_TYPE>, _tree<USER_DATA, NODE_TYPE>::element, NODE_TYPE>(p_in) { init(p_in, _first, _last); };
                    iterator(element*& p_in[], const int _first = NULL, const int count = WHOLE_ARRAY) : _iterator<USER_DATA, USER_DATA, _tree<USER_DATA, NODE_TYPE>, _tree<USER_DATA, NODE_TYPE>::element, NODE_TYPE>(p_in, _first, count) { };
                    iterator(element& p_in[], const int _first = NULL, const int count = WHOLE_ARRAY) : _iterator<USER_DATA, USER_DATA, _tree<USER_DATA, NODE_TYPE>, _tree<USER_DATA, NODE_TYPE>::element, NODE_TYPE>(p_in, _first, count) { };


                    virtual USER_DATA get() const { return(p_list[p_cnt].p_element_obj.get_key()); };
                    template <typename CUSTOM_TYPE>
                    const bool init(_tree<USER_DATA, NODE_TYPE>& p_in, CUSTOM_TYPE _first, CUSTOM_TYPE _last) { _remove_deleted(p_cnt == -1); iter_size = p_in.get_range(p_list, _first, _last); return(_init()); };
                    const bool init(_tree<USER_DATA, NODE_TYPE>& p_in, USER_DATA& _first, USER_DATA& _last) { _remove_deleted(p_cnt == -1); iter_size = p_in.get_range(p_list, _first, _last); return(_init()); };
                };



            private:


                template <typename ELEMENT_TYPE>
                class _tree_traversal
                {
                    public:

                    const _obj_cast<USER_DATA, ELEMENT_TYPE, NODE_TYPE> p_obj_cast;
                    const NODE_TYPE* _p_stop;
                            NODE_TYPE* _p_node;
                            int _cnt;
                            int _arr_ptr;
                    const int _cnt_limit;
                    const bool _reverse;


                    _tree_traversal(_param_details<NODE_TYPE>* _ec_params, NODE_TYPE* _first_node, NODE_TYPE* _last_node, const int limit, const bool reverse) :
                        p_obj_cast (_ec_params),
                        _p_stop ((reverse) ? _first_node : _last_node),
                        _p_node ((reverse) ? _last_node : _first_node),
                        _cnt (NULL),
                        _arr_ptr (NULL),
                        _cnt_limit (limit),
                        _reverse (reverse)
                    { };

                    template <typename T>
                    void cast(T& __arr_in[]) const
                    { p_obj_cast.cast_obj(__arr_in, _p_node, _arr_ptr); };
                };


            protected:



                _tree(const bool _do_not_destroy = false) :
                    _element_collection<USER_DATA, NODE_TYPE>(_do_not_destroy)
                { p_element = new element(NULL, p_params); };


                _tree(const _tree<USER_DATA, NODE_TYPE>& p_in) :
                    _element_collection<USER_DATA, NODE_TYPE>(p_in.p_params)
                { p_element = new element(NULL, p_params); };


                ~_tree()
                { reset(true); };




                void reset(const bool _delete = false)
                {
                    if(::CheckPointer(p_params) == POINTER_INVALID)
                    { return; }

                    if(p_params.instance_cnt == 1)
                    {

                        if(p_params.do_not_destroy)
                        { p_params.p_root.detach_obj(); }


                        delete_subtree(p_params.p_root);


                        if(p_params.p_root != NULL)
                        { delete(p_params.p_root); }
                    }
                    p_params.clear(_delete);
                };




                void operator=(_tree<USER_DATA, NODE_TYPE>& p_in)
                {

                    reset();


                    _element_collection<USER_DATA, NODE_TYPE>::operator=(p_in);
                };




                const bool operator!=(const _tree<USER_DATA, NODE_TYPE>& p_in)
                { return(!operator==(p_in)); };

                const bool operator==(const _tree<USER_DATA, NODE_TYPE>& p_in)
                { return(p_params == p_in.p_params); };


            public:


                template <typename CUSTOM_DATA>
                element* operator[](CUSTOM_DATA* p_in) { return((p_params.p_root != NULL) && (p_element.set(p_params.p_root._cast_indexing_operator(p_in))) ? p_element : NULL); };
                template <typename CUSTOM_DATA>
                element* operator[](CUSTOM_DATA& p_in) { return((p_params.p_root != NULL) && (p_element.set(p_params.p_root._cast_indexing_operator(p_in))) ? p_element : NULL); };
                template <typename CUSTOM_DATA>
                element* operator[](CUSTOM_DATA p_in) { return((p_params.p_root != NULL) && (p_element.set(p_params.p_root._cast_indexing_operator(p_in))) ? p_element : NULL); };
                element* operator[](USER_DATA& p_in) { return((p_params.p_root != NULL) && (p_element.set(p_params.p_root.operator[](p_in))) ? p_element : NULL); };




                template <typename ARRAY_TYPE>
                const int get_array(ARRAY_TYPE& __p_arr[], const bool reverse = false) { USER_DATA tmp; return(_get_array<ARRAY_TYPE, element>(__p_arr, tmp, tmp, WHOLE_ARRAY, reverse, true)); };
                template <typename ARRAY_TYPE>
                const int get_array(ARRAY_TYPE& __p_arr[], USER_DATA& start, const bool reverse = false) { USER_DATA tmp; return(_get_array<ARRAY_TYPE, element>(__p_arr, start, tmp, WHOLE_ARRAY, reverse, false)); };
                template <typename ARRAY_TYPE>
                const int get_array(ARRAY_TYPE& __p_arr[], USER_DATA& start, const int count, const bool reverse = false) { USER_DATA tmp; return(_get_array<ARRAY_TYPE, element>(__p_arr, start, tmp, count, reverse, false)); };
                template <typename ARRAY_TYPE>
                const int get_range(ARRAY_TYPE& __p_arr[], USER_DATA& start, USER_DATA& end) { return(_get_array<ARRAY_TYPE, element>(__p_arr, start, end, 0, false, true)); };


            protected:



                template <typename ARRAY_TYPE, typename ELEMENT_TYPE>
                const int _get_array(ARRAY_TYPE& __p_arr[], USER_DATA& _first_obj, USER_DATA& _last_obj, const int count, const bool _reverse, const bool whole_tree)
                {

                    if(p_params.p_root == NULL)
                    {
                        ArrayFree(__p_arr);
                        return(NULL);
                    }


                    const bool swap_values = ((count == 0) && (whole_tree) && (_first_obj > _last_obj));
                    const bool reverse = _reverse || swap_values;
                    const int _size = (count > NULL) ? MathMin(count, p_params._size) : p_params._size;
                    _tree_traversal<ELEMENT_TYPE> local_t_obj ( p_params,
                                                                        ((whole_tree) && (count == WHOLE_ARRAY)) ?
                                                                            p_params.p_left
                                                                          : ((swap_values) ? p_params.p_root.next_greater_element(_last_obj, true) : p_params.p_root.next_greater_element(_first_obj, true)),
                                                                        ((whole_tree) && (count == 0)) ?
                                                                            ((swap_values) ? p_params.p_root.next_smaller_element(_first_obj, true) : p_params.p_root.next_smaller_element(_last_obj, true))
                                                                          : p_params.p_right,
                                                                        _size,
                                                                        reverse
                                                                        );
                    _tree_traversal<ELEMENT_TYPE>* _t_obj = GetPointer(local_t_obj);
                    NODE_TYPE* p_this = _t_obj._p_node;
                    NODE_TYPE* p_this_parent = p_this.parent_element();



                    ArrayFree(__p_arr);
                    ArrayResize(__p_arr, _size);


                    while( (_t_obj._p_node != NULL)
                        && (!_StopFlag) )
                    {

                        _t_obj.cast(__p_arr);
                        _t_obj._arr_ptr++;
                        _t_obj._cnt = ((_t_obj._p_node != _t_obj._p_stop) ? _t_obj._cnt : _t_obj._cnt_limit) + 1;
                        _t_obj._p_node = (reverse) ? p_this.left_element() : p_this.right_element();


                        traverse_sub_tree(__p_arr, _t_obj);
                        p_this_parent = (_t_obj._cnt < _t_obj._cnt_limit) ? p_this_parent : NULL;


                        do
                        {
                            _t_obj._p_node = p_this;
                            p_this = p_this_parent;
                            p_this_parent = (p_this != NULL) ? p_this.parent_element() : NULL;
                        }
                        while( (p_this != NULL)
                            && (((reverse) ? p_this.left_element() : p_this.right_element()) == _t_obj._p_node) );


                        _t_obj._p_node = p_this;
                    }
                    _t_obj._cnt = ArrayResize(__p_arr, _t_obj._arr_ptr);


                    return((_StopFlag) ? NULL : _t_obj._cnt);
                };


            protected:


                const bool _insert(NODE_TYPE* p_new)
                {

                    if(p_params.p_root == NULL)
                    {
                        p_params.p_root = p_new;
                        p_params.p_left = p_new;
                        p_params.p_right = p_new;
                        p_params.p_last_added = p_new;
                        p_params._size++;
                    }
                    else
                    {
                        NODE_TYPE* _root = p_new.insert(p_params.p_root);
                        if(_root == NULL)
                        { return(false); }
                        p_params.p_root = _root;
                        p_params.p_left = (p_params.p_left > p_new) ? p_new : p_params.p_left;
                        p_params.p_right = (p_new > p_params.p_right) ? p_new : p_params.p_right;
                        p_params.p_last_added = p_new;
                        p_params._size++;
                    }


                    return(true);
                };

                const bool _remove(NODE_TYPE* p_remove, const bool _do_not_destroy = false)
                {

                    if(p_remove == NULL)
                    { return(false); }


                    NODE_TYPE* p_node = p_remove.parent_element();
                    NODE_TYPE* _root = p_remove.remove(p_params.p_root, p_params.do_not_destroy);
                    p_node = (p_node == NULL) ? _root : p_node;


                    p_params._size--;
                    if(p_params._size == NULL)
                    {
                        p_params.p_root = NULL;
                        p_params.p_left = NULL;
                        p_params.p_right = NULL;
                        p_params.p_last_added = NULL;
                    }
                    else
                    {
                        p_params.p_root = (_root != NULL) ? _root : p_params.p_root;
                        p_params.p_left = (p_params.p_left != p_remove) ? p_params.p_left : p_node.smallest_node();
                        p_params.p_right = (p_params.p_right != p_remove) ? p_params.p_right : p_node.greatest_node();
                        p_params.p_last_added = (p_params.p_last_added == p_remove) ? NULL : p_params.p_last_added;
                    }


                    if(p_params.do_not_destroy || _do_not_destroy)
                    { p_remove.detach_obj(); }
                    delete(p_remove);


                    return(true);
                };


            private:



                template <typename ARRAY_TYPE, typename TRAVERSE_OBJ>
                void traverse_sub_tree(ARRAY_TYPE& __p_arr[], TRAVERSE_OBJ* _t_obj)
                {

                    if(_t_obj._p_node == NULL)
                    { return; }


                    NODE_TYPE* __ptr = _t_obj._p_node;


                    _t_obj._p_node = (_t_obj._reverse) ? __ptr.right_element() : __ptr.left_element();
                    traverse_sub_tree(__p_arr, _t_obj);


                    if(_t_obj._cnt < _t_obj._cnt_limit)
                    {
                        _t_obj._p_node = __ptr;
                        _t_obj.cast(__p_arr);
                        _t_obj._arr_ptr++;
                        _t_obj._cnt = (_t_obj._p_node == _t_obj._p_stop) ? _t_obj._cnt_limit : (_t_obj._cnt + 1);
                    }


                    _t_obj._p_node = (_t_obj._reverse) ? __ptr.left_element() : __ptr.right_element();
                    _t_obj._p_node = (_t_obj._cnt < _t_obj._cnt_limit) ? _t_obj._p_node : NULL;
                    traverse_sub_tree(__p_arr, _t_obj);
                };


                void delete_subtree(NODE_TYPE* p_in)
                {

                    if(p_in == NULL)
                    { return; }

                    NODE_TYPE* sub_node = p_in.left_element();


                    if(sub_node != NULL)
                    {
                        if(p_params.do_not_destroy)
                        { sub_node.detach_obj(); }

                        delete_subtree(sub_node);

                        if(CheckPointer(sub_node) != POINTER_INVALID)
                        {
                            delete(sub_node);
                            p_params._size--;
                        }
                    }


                    sub_node = p_in.right_element();
                    if(sub_node != NULL)
                    {
                        if(p_params.do_not_destroy)
                        { sub_node.detach_obj(); }

                        delete_subtree(sub_node);

                        if(CheckPointer(sub_node) != POINTER_INVALID)
                        {
                            delete(sub_node);
                            p_params._size--;
                        }
                    }
                };


            public:



                template <typename CUSTOM_DATA>
                const int insert(CUSTOM_DATA*& p_in[], const bool ignore_duplicates = true)
                {
                    const int count = ArraySize(p_in);
                    int ptr = count / 2;
                    int insert_cnt = NULL;
                    bool __stop = false;
                    bool failed = false;
                    int valid_data = NULL;
                    NODE_TYPE* p_new = NULL;
                    for(int cnt = NULL; (cnt < count) && !__stop; cnt++, ptr++)
                    {
                        p_new = new NODE_TYPE(p_in[ptr % count], valid_data);
                        failed = (!valid_data) || (!_insert(p_new));
                        if(failed)
                        {
                  if(valid_data)
                  { p_new._autodelete(p_in[ptr % count]); }
                            p_new.detach_obj();
                            delete(p_new);
                        }
                        __stop |= _StopFlag || (failed && !ignore_duplicates);
                        insert_cnt += !failed;
                    }
                    return(insert_cnt);
                };

                template <typename CUSTOM_DATA>
                const int insert(CUSTOM_DATA& p_in[], const bool ignore_duplicates = true)
                {
                    const int count = ArraySize(p_in);
                    int ptr = count / 2;
                    int insert_cnt = NULL;
                    bool __stop = false;
                    bool failed = false;
                    int valid_data = NULL;
                    NODE_TYPE* p_new = NULL;
                    for(int cnt = NULL; (cnt < count) && !__stop; cnt++, ptr++)
                    {
                        p_new = new NODE_TYPE(p_in[ptr % count], valid_data);
                        failed = (!valid_data) || !_insert(p_new);
                        if(failed)
                        {
                            if(valid_data)
                            { p_new._autodelete(p_in[ptr % count]); }
                            p_new.detach_obj();
                            delete(p_new);
                        }
                        __stop |= _StopFlag || (failed && !ignore_duplicates);
                        insert_cnt += !failed;
                    }
                    return(insert_cnt);
                };

                template <typename CUSTOM_DATA>
                const bool insert(CUSTOM_DATA p_in)
                {

                    int valid_data = NULL;
                    NODE_TYPE* p_new = new NODE_TYPE(p_in, valid_data);


                    if( (valid_data)
                    && (_insert(p_new)) )
                    { return(true); }


                    if(valid_data)
                    { p_new._autodelete(p_in); }
                    p_new.detach_obj();
                    delete(p_new);


                    return(false);
                };

                template <typename CUSTOM_DATA>
                const bool insert(CUSTOM_DATA& p_in)
                {

                    int valid_data = NULL;
                    NODE_TYPE* p_new = new NODE_TYPE(p_in, valid_data);


                    if( (valid_data)
                    && (_insert(p_new)) )
                    { return(true); }


                    if(valid_data)
                    { p_new._autodelete(p_in); }
                    p_new.detach_obj();
                    delete(p_new);


                    return(false);
                };

                const bool insert(const USER_DATA& p_in)
                {

                    int valid_data = NULL;
                    NODE_TYPE* p_new = new NODE_TYPE(p_in, valid_data);


                    if( (valid_data)
                    && (_insert(p_new)) )
                    { return(true); }


                    if(valid_data)
                    { p_new._autodelete(p_in); }
                    p_new.detach_obj();
                    delete(p_new);


                    return(false);
                };

                const bool insert(USER_DATA& p_in)
                {

                    int valid_data = NULL;
                    NODE_TYPE* p_new = new NODE_TYPE(p_in, valid_data);


                    if(_insert(p_new))
                    { return(true); }


                    p_new.detach_obj();
                    delete(p_new);


                    return(false);
                };



                template <typename CUSTOM_DATA>
                const int remove(CUSTOM_DATA& p_in[], const bool _do_not_destroy = false)
                {

                    int retval = NULL;


                    for(int cnt = (p_params.p_root == NULL) ? -1 : (ArraySize(p_in) - 1); (cnt >= NULL) && !_StopFlag; cnt--)
                    { retval += _remove(p_params.p_root._cast_indexing_operator(p_in[cnt]), _do_not_destroy); }


                    return(retval);
                };

                const int remove(USER_DATA& p_in[], const bool _do_not_destroy = false)
                {

                    int retval = NULL;


                    for(int cnt = (p_params.p_root == NULL) ? -1 : (ArraySize(p_in) - 1); (cnt >= NULL) && !_StopFlag; cnt--)
                    { retval += _remove(p_params.p_root.operator[](p_in[cnt]), _do_not_destroy); }


                    return(retval);
                };

                template <typename CUSTOM_DATA>
                const bool remove(CUSTOM_DATA* p_in, const bool _do_not_destroy = false)
                { return((p_params.p_root == NULL) ? false : _remove(p_params.p_root._cast_indexing_operator(p_in), _do_not_destroy)); };

                template <typename CUSTOM_DATA>
                const bool remove(CUSTOM_DATA& p_in, const bool _do_not_destroy = false)
                { return((p_params.p_root == NULL) ? false : _remove(p_params.p_root._cast_indexing_operator(p_in), _do_not_destroy)); };

                template <typename CUSTOM_DATA>
                const bool remove(CUSTOM_DATA p_in, const bool _do_not_destroy = false)
                { return((p_params.p_root == NULL) ? false : _remove(p_params.p_root._cast_indexing_operator(p_in), _do_not_destroy)); };

                const bool remove(USER_DATA& p_in, const bool _do_not_destroy = false)
                { return((p_params.p_root == NULL) ? false : _remove(p_params.p_root.operator[](p_in), _do_not_destroy)); };



                template <typename CUSTOM_DATA>
                const NODE_TYPE* greater(CUSTOM_DATA* p_in) const
                { return((p_params.p_root == NULL) ? NULL : p_params.p_root._cast_next_greater_operator(p_in, false)); };

                template <typename CUSTOM_DATA>
                const NODE_TYPE* greater(CUSTOM_DATA& p_in) const
                { return((p_params.p_root == NULL) ? NULL : p_params.p_root._cast_next_greater_operator(p_in, false)); };

                template <typename CUSTOM_DATA>
                const NODE_TYPE* greater(CUSTOM_DATA p_in) const
                { return((p_params.p_root == NULL) ? NULL : p_params.p_root._cast_next_greater_operator(p_in, false)); };

                const NODE_TYPE* greater(USER_DATA& p_in) const
                { return((p_params.p_root == NULL) ? NULL : p_params.p_root.next_greater_element(p_in, false)); };
//# 757 "lib_structures/base/lib_base_tree.mqh"
                template <typename CUSTOM_DATA>
                const NODE_TYPE* smaller(CUSTOM_DATA* p_in) const
                { return((p_params.p_root == NULL) ? NULL : p_params.p_root._cast_next_smaller_operator(p_in, false)); };

                template <typename CUSTOM_DATA>
                const NODE_TYPE* smaller(CUSTOM_DATA& p_in) const
                { return((p_params.p_root == NULL) ? NULL : p_params.p_root._cast_next_smaller_operator(p_in, false)); };

                template <typename CUSTOM_DATA>
                const NODE_TYPE* smaller(CUSTOM_DATA p_in) const
                { return((p_params.p_root == NULL) ? NULL : p_params.p_root._cast_next_smaller_operator(p_in, false)); };

                const NODE_TYPE* smaller(USER_DATA& p_in) const
                { return((p_params.p_root == NULL) ? NULL : p_params.p_root.next_smaller_element(p_in, false)); };
//# 790 "lib_structures/base/lib_base_tree.mqh"
            public:



                NODE_TYPE* get_tree_root()
                { return(p_params.p_root); }

                void validate_node_pointers()
                {
                    printf("Validating NULL-Nodes; current size: %i", p_params._size);
                    NODE_TYPE* p_root = p_params.p_root;
                    traverse_tree_nodes(p_root);
                }

                void traverse_tree_nodes(NODE_TYPE* p_parent)
                {
                    if(p_parent == NULL)
                    { return; }

                    if(CheckPointer(p_parent) != POINTER_INVALID)
                    {
                        if(p_parent.left_element() != NULL)
                        {
                            if(CheckPointer(p_parent.left_element()) != POINTER_INVALID)
                            { traverse_tree_nodes(p_parent.left_element()); }
                            else
                            { DebugBreak(); }
                        }

                        if(p_parent.right_element() != NULL)
                        {
                            if(CheckPointer(p_parent.right_element()) != POINTER_INVALID)
                            { traverse_tree_nodes(p_parent.right_element()); }
                            else
                            { DebugBreak(); }
                        }

                        return;
                    }

                    DebugBreak();
                    return;
                }



                void print_tree_size(const string comment = "")
                { print_tree(comment, true); };

                void print_tree(const string comment = "", const bool size_only = false)
                {
                    int count = NULL;
                    string out = "";
                    string out_buffer[];
                    _print_tree(p_params.p_root, 0, out, count, out_buffer);

                    if(size_only)
                    {
                        printf("Elements counted: %i", count);
                        return;
                    }

                    printf("********* TREE BEGIN (%s) *************", comment);
                    for(int cnt = NULL; cnt < ArraySize(out_buffer); cnt++)
                    { printf("%s", out_buffer[cnt]); }
                    printf("%s\nElements: %i\n********* TREE END *************", out, count);


                    return;
                }

                void _print_tree(NODE_TYPE* _root, const int lvl, string& out, int& count, string& out_buffer[])
                {
                    if(_root == NULL)
                    {
                        StringSetLength(out, StringLen(out) - 1);
                        out += "---<empty>---\n";
                        return;
                    }


                    _print_tabs(out, lvl, out_buffer);
                    string node_out = _root._node_to_string(count);


                    if(node_out == NULL)
                    {
                        out += "\n !!! ERROR IN NODE HIRARCHY !!! \n\n";
                        return;
                    }


                    out += StringFormat("%s\n", node_out);


                    _print_tabs(out, lvl, out_buffer);
                    out += " -> left: \n";
                    _print_tree(_root.left_element(), lvl + 1, out, count, out_buffer);


                    _print_tabs(out, lvl, out_buffer);
                    out += " -> right: \n";
                    _print_tree(_root.right_element(), lvl + 1, out, count, out_buffer);

                    _print_tabs(out, lvl, out_buffer);
                    out += "Done\n";
                }

                void _print_tabs(string& out, const int lvl, string& out_buffer[])
                {
                    _print_max_len(out, out_buffer);
                    out += StringFormat("%i:  ", lvl); for(int cnt = NULL; (cnt < lvl); cnt++) { out += "   "; }
                };

                void _print_max_len(string& out, string& out_buffer[])
                {
                    if(StringLen(out) > 4096)
                    {
                        const int ptr = ArrayResize(out_buffer, ArraySize(out_buffer) + 1) - 1;
                        out_buffer[ptr] = out;
                        out = "";
                    }
                };
        };
//# 33 "lib_structures/lib_tree.mqh" 2
//# 65 "lib_structures/lib_tree.mqh"
        template <typename USER_DATA>
        struct tree : public _tree<USER_DATA, object_rb_tree_node<USER_DATA> >
        {
            public:



                tree() : _tree<USER_DATA, object_rb_tree_node<USER_DATA> >(_is_USER_DATA_ptr()) { };
                tree(const tree<USER_DATA>& p_in) : _tree<USER_DATA, object_rb_tree_node<USER_DATA> >(p_in) { };
                ~tree() { };


                void operator=(const tree<USER_DATA>& p_in) { _tree<USER_DATA, object_rb_tree_node<USER_DATA> >::operator=((_tree<USER_DATA, object_rb_tree_node<USER_DATA> >)p_in); };


                void clear() { _tree<USER_DATA, object_rb_tree_node<USER_DATA> >::reset(); };





                template <typename CUSTOM_DATA>
                const int add(CUSTOM_DATA*& p_in[]) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::insert(p_in)); };
                template <typename CUSTOM_DATA>
                const int add(CUSTOM_DATA& p_in[]) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::insert(p_in)); };
                template <typename CUSTOM_DATA>
                const bool add(CUSTOM_DATA* p_in) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::insert(p_in)); };
                template <typename CUSTOM_DATA>
                const bool add(const CUSTOM_DATA* p_in) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::insert(p_in)); };
                template <typename CUSTOM_DATA>
                const bool add(CUSTOM_DATA& p_in) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::insert(p_in)); };
                template <typename CUSTOM_DATA>
                const bool add(CUSTOM_DATA p_in) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::insert(p_in)); };
                const int add(const USER_DATA& p_in[]) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::insert(p_in)); };
                const bool add(const USER_DATA& p_in) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::insert(p_in)); };


                template <typename CUSTOM_DATA>
                const int remove(CUSTOM_DATA& p_in[]) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::remove(p_in)); };
                template <typename CUSTOM_DATA>
                const bool remove(CUSTOM_DATA* p_in) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::remove(p_in)); };
                template <typename CUSTOM_DATA>
                const bool remove(CUSTOM_DATA& p_in) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::remove(p_in)); };
                template <typename CUSTOM_DATA>
                const bool remove(CUSTOM_DATA p_in) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::remove(p_in)); };
                const int remove(USER_DATA& p_in[]) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::remove(p_in)); };
                const bool remove(USER_DATA& p_in) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::remove(p_in)); };


                USER_DATA minimum() { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::first_element().get_key()); };
                USER_DATA maximum() { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::last_element().get_key()); };


                template <typename CUSTOM_DATA>
                USER_DATA next_smaller(CUSTOM_DATA* p_in) { const object_rb_tree_node<USER_DATA>* p_node = _tree<USER_DATA, object_rb_tree_node<USER_DATA> >::smaller(p_in); if(p_node == NULL) { USER_DATA _tmp; ZeroMemory(_tmp); return(_tmp); } return(p_node.get_key()); };
                template <typename CUSTOM_DATA>
                USER_DATA next_smaller(CUSTOM_DATA& p_in) { const object_rb_tree_node<USER_DATA>* p_node = _tree<USER_DATA, object_rb_tree_node<USER_DATA> >::smaller(p_in); if(p_node == NULL) { USER_DATA _tmp; ZeroMemory(_tmp); return(_tmp); } return(p_node.get_key()); };
                template <typename CUSTOM_DATA>
                USER_DATA next_smaller(CUSTOM_DATA p_in) { const object_rb_tree_node<USER_DATA>* p_node = _tree<USER_DATA, object_rb_tree_node<USER_DATA> >::smaller(p_in); if(p_node == NULL) { USER_DATA _tmp; ZeroMemory(_tmp); return(p_in); } return(p_node.get_key()); };
                USER_DATA next_smaller(const USER_DATA& p_in) { const object_rb_tree_node<USER_DATA>* p_node = _tree<USER_DATA, object_rb_tree_node<USER_DATA> >::smaller(p_in); if(p_node == NULL) { USER_DATA _tmp; ZeroMemory(_tmp); return(_tmp); } return(p_node.get_key()); };
                USER_DATA next_smaller(USER_DATA& p_in) { const object_rb_tree_node<USER_DATA>* p_node = _tree<USER_DATA, object_rb_tree_node<USER_DATA> >::smaller(p_in); if(p_node == NULL) { USER_DATA _tmp; ZeroMemory(_tmp); return(p_in); } return(p_node.get_key()); };

                template <typename CUSTOM_DATA>
                USER_DATA next_greater(CUSTOM_DATA* p_in) { const object_rb_tree_node<USER_DATA>* p_node = _tree<USER_DATA, object_rb_tree_node<USER_DATA> >::greater(p_in); if(p_node == NULL) { USER_DATA _tmp; ZeroMemory(_tmp); return(_tmp); } return(p_node.get_key()); };
                template <typename CUSTOM_DATA>
                USER_DATA next_greater(CUSTOM_DATA& p_in) { const object_rb_tree_node<USER_DATA>* p_node = _tree<USER_DATA, object_rb_tree_node<USER_DATA> >::greater(p_in); if(p_node == NULL) { USER_DATA _tmp; ZeroMemory(_tmp); return(_tmp); } return(p_node.get_key()); };
                template <typename CUSTOM_DATA>
                USER_DATA next_greater(CUSTOM_DATA p_in) { const object_rb_tree_node<USER_DATA>* p_node = _tree<USER_DATA, object_rb_tree_node<USER_DATA> >::greater(p_in); if(p_node == NULL) { USER_DATA _tmp; ZeroMemory(_tmp); return(_tmp); } return(p_node.get_key()); };
                USER_DATA next_greater(const USER_DATA& p_in) { const object_rb_tree_node<USER_DATA>* p_node = _tree<USER_DATA, object_rb_tree_node<USER_DATA> >::greater(p_in); if(p_node == NULL) { USER_DATA _tmp; ZeroMemory(_tmp); return(_tmp); } return(p_node.get_key()); };
                USER_DATA next_greater(USER_DATA& p_in) { const object_rb_tree_node<USER_DATA>* p_node = _tree<USER_DATA, object_rb_tree_node<USER_DATA> >::greater(p_in); if(p_node == NULL) { USER_DATA _tmp; ZeroMemory(_tmp); return(_tmp); } return(p_node.get_key()); };




                const bool operator==(const tree<USER_DATA>& p_in) { return(_tree<USER_DATA, object_rb_tree_node<USER_DATA> >::operator==((_tree<USER_DATA, object_rb_tree_node<USER_DATA> >)p_in)); }
                const bool operator!=(const tree<USER_DATA>& p_in) { return(!operator==(p_in)); }
        };
//# 172 "lib_structures/lib_tree.mqh"
        template <typename USER_DATA>
        struct ptr_tree : public _tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >
        {
            public:



                ptr_tree() : _tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >(false) { };
                ptr_tree(const ptr_tree<USER_DATA>& p_in) : _tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >(p_in) { };
                ptr_tree(const bool _do_not_take_object_ownership) : _tree(_do_not_take_object_ownership) { };
                ~ptr_tree() { };


                void operator=(const ptr_tree<USER_DATA>& p_in) { _tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::operator=((_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >)p_in); };


                const bool dnd() { return(p_params.do_not_destroy); };
                const bool dnd(const bool _do_not_destroy) { p_params.do_not_destroy |= _do_not_destroy; return(p_params.do_not_destroy); };


                void clear() { _tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::reset(); };





                template <typename CUSTOM_DATA>
                const bool add(CUSTOM_DATA& p_in) { USER_DATA* tmp_ptr = (USER_DATA*)new CUSTOM_DATA(p_in); return(_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::insert(tmp_ptr)); };
                const bool add(USER_DATA& p_in) { USER_DATA* tmp_ptr = new USER_DATA(p_in); return(_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::insert(tmp_ptr)); };
                template <typename CUSTOM_DATA>
                const bool add(CUSTOM_DATA* p_in) { USER_DATA* p_tmp = (USER_DATA*)p_in; return(_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::insert(p_tmp)); };
                const bool add(USER_DATA* p_in) { return(_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::insert(p_in)); };


                template <typename CUSTOM_DATA>
                const int add(CUSTOM_DATA& p_in[]) { int count = NULL; for(int cnt = ArraySize(p_in) - 1; (cnt >= NULL) && !_StopFlag; cnt--) { count += add(p_in[cnt]); } return(count); };
                template <typename CUSTOM_DATA>
                const int add(CUSTOM_DATA*& p_in[]) { int count = NULL; for(int cnt = ArraySize(p_in) - 1; (cnt >= NULL) && !_StopFlag; cnt--) { count += add(p_in[cnt]); } return(count); };
                const int add(USER_DATA*& p_in[]) { return(_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::insert(p_in)); };



                template <typename CUSTOM_DATA>
                const bool remove(CUSTOM_DATA& p_in, const bool _do_not_destroy = false) { USER_DATA* tmp_ptr = (USER_DATA*)GetPointer(p_in); return(_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::remove(tmp_ptr, p_params.do_not_destroy || _do_not_destroy)); };
                const bool remove(USER_DATA& p_in, const bool _do_not_destroy = false) { USER_DATA* tmp_ptr = GetPointer(p_in); return(_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::remove(tmp_ptr, p_params.do_not_destroy || _do_not_destroy)); };
                template <typename CUSTOM_DATA>
                const bool remove(CUSTOM_DATA* p_in, const bool _do_not_destroy = false) { USER_DATA* p_tmp = (USER_DATA*)p_in; return(_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::remove(p_tmp, p_params.do_not_destroy || _do_not_destroy)); };
                const bool remove(USER_DATA* p_in, const bool _do_not_destroy = false) { return(_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::remove(p_in, p_params.do_not_destroy || _do_not_destroy)); };


                template <typename CUSTOM_DATA>
                const int remove(CUSTOM_DATA& p_in[], const bool _do_not_destroy = false) { int count = NULL; for(int cnt = ArraySize(p_in) - 1; (cnt >= NULL) && !_StopFlag; cnt--) { count += remove(p_in[cnt], _do_not_destroy); } return(count); };
                template <typename CUSTOM_DATA>
                const int remove(CUSTOM_DATA*& p_in[], const bool _do_not_destroy = false) { int count = NULL; for(int cnt = ArraySize(p_in) - 1; (cnt >= NULL) && !_StopFlag; cnt--) { count += remove(p_in[cnt], _do_not_destroy); } return(count); };
                const int remove(USER_DATA*& p_in[], const bool _do_not_destroy = false) { return(_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::remove(p_in, p_params.do_not_destroy || _do_not_destroy)); };



                USER_DATA* minimum() { return(_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::first_element().get_key()); };
                USER_DATA* maximum() { return(_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::last_element().get_key()); };

                template <typename CUSTOM_DATA>
                USER_DATA* next_smaller(CUSTOM_DATA& p_in) { USER_DATA* tmp_ptr = (USER_DATA*)GetPointer(p_in); ptr_object_rb_tree_node<USER_DATA>* p_tmp = _tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::smaller(tmp_ptr); return((p_tmp != NULL) ? p_tmp.get_key() : NULL); };
                USER_DATA* next_smaller(USER_DATA& p_in) { USER_DATA* tmp_ptr = GetPointer(p_in); ptr_object_rb_tree_node<USER_DATA>* p_tmp = _tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::smaller(tmp_ptr); return((p_tmp != NULL) ? p_tmp.get_key() : NULL); };

                template <typename CUSTOM_DATA>
                USER_DATA* next_smaller(CUSTOM_DATA* p_in) { USER_DATA* tmp_ptr = (USER_DATA*)p_in; ptr_object_rb_tree_node<USER_DATA>* p_tmp = _tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::smaller(tmp_ptr); return((p_tmp != NULL) ? p_tmp.get_key() : NULL); };
                USER_DATA* next_smaller(USER_DATA* p_in) { const ptr_object_rb_tree_node<USER_DATA>* p_tmp = _tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::smaller(p_in); return((p_tmp != NULL) ? p_tmp.get_key() : NULL); };

                template <typename CUSTOM_DATA>
                USER_DATA* next_greater(CUSTOM_DATA& p_in) { USER_DATA* tmp_ptr = (USER_DATA*)GetPointer(p_in); ptr_object_rb_tree_node<USER_DATA>* p_tmp = _tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::greater(tmp_ptr); return((p_tmp != NULL) ? p_tmp.get_key() : NULL); };
                USER_DATA* next_greater(USER_DATA& p_in) { USER_DATA* tmp_ptr = GetPointer(p_in); ptr_object_rb_tree_node<USER_DATA>* p_tmp = _tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::greater(tmp_ptr); return((p_tmp != NULL) ? p_tmp.get_key() : NULL); };

                template <typename CUSTOM_DATA>
                USER_DATA* next_greater(CUSTOM_DATA* p_in) { USER_DATA* tmp_ptr = (USER_DATA*)p_in; ptr_object_rb_tree_node<USER_DATA>* p_tmp = _tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::greater(tmp_ptr); return((p_tmp != NULL) ? p_tmp.get_key() : NULL); };
                USER_DATA* next_greater(USER_DATA* p_in) { const ptr_object_rb_tree_node<USER_DATA>* p_tmp = _tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::greater(p_in); return((p_tmp != NULL) ? p_tmp.get_key() : NULL); };




                const bool operator==(const ptr_tree<USER_DATA>& p_in) { return(_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >::operator==((_tree<USER_DATA*, ptr_object_rb_tree_node<USER_DATA> >)p_in)); }
                const bool operator!=(const ptr_tree<USER_DATA>& p_in) { return(!operator==(p_in)); }
        };
